/*------------------------------------------------------------------*/
/*                                               */
/*------------------------------------------------------------------*/

#ifndef tdata_genH                 
#define tdata_genH

#include <vcl.h>
#include "Alinit.h"
#include "TypeData.h"

#define MAXPOINT            10000   //   
#define MAX_ADD_SECT        1000    //    
#define MAX_EDGE            500    //    
#define MAX_MAIN_SECT       500    //    
#define MAX_BASE_POINT      500    //    ,   
#define MAX_ADD_SPAN        50     //   
#define MAX_ARBIT_LOAD      100     //     ( 50)
#define MAX_PLAN_LOAD       500     //    
#define MAX_MACRO           10000   //   
#define MAX_PLAN_CONSTRAINT 50
#define MAX_RESULT          1000
#define SIZE_NAME_RESULT    121
#define MAX_LOAD_SET        150    //       (  100)

#define SIZE_VAR_NAME       1200   //    
#define MAX_VAR_SET         150    //     

//#define SIZE_VAR_NAME       50   //    
//#define MAX_VAR_SET         50    //     

#define MAXG_POINT          1000    //     
#define MAXG_LINE           1000    //    ( )

#define ONE_SPAN_DOWN       0
#define ONE_SPAN_DOUBLE_UP  1
#define ONE_SPAN_SINGLE_UP  2
#define MANY_SPAN_DOWN      3
#define MANY_SPAN_UP        4
#define MANY_SPAN_UP_MK     5
#define ARBIT_RAMA          6      //  
#define SEGMENT_RAMA        7
#define MANY_SPAN_LEVEL     8      //  
#define ARBIT_UNIT          9

#define MAX_JOINT          500
#define MAX_SELECT         10000    //    
#define NSIGN              134       //    
#define SIGN_SECT "ŨABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789@#$%&*abcdefghijklmnoqprstuvwxyz"

#define MAX_CRAN_PARAM  50     //   
#define MAX_CRAN_LOAD   180     //    
#define MAX_CRAN_COMB   30      //    

#define NUMBER_MAIN_SECT_DOWN          11
#define NUMBER_MAIN_POINT_DOWN         16

#define NUMBER_MAIN_SECT_UP            9
#define NUMBER_MAIN_SECT_UP1           7
#define NUMBER_MAIN_SECT_MD_DOWN       11
#define NUMBER_MAIN_SECT_MANY_UP       9
#define NUMBER_MAIN_SECT_MANY_UP_MK    6
#define NUMBER_MAIN_SECT_SEGMENT       3
#define NUMBER_MAIN_SECT_MANY_LEVEL    9

#define NO_CHOISE          0
#define DVUTAVR            1
#define SQUARE_TUBE        2
#define RECT_TUBE          3
#define CIRCULAR_TUBE      4
#define RECTANCULAR        5
#define SHVELLER           6
#define TAVR_UP            7
#define TAVR_DOWN          8
//#define DVUTAVR_YZ         9

#define GNU_CH              10
#define GNU_C              11
#define GNU_Z              12
#define GNU_ZC             13
#define GNU_SIGMA          14
#
#define EDGE_DOUBLE_ALL    1
#define EDGE_SINGLE_ALL    2
#define EDGE_DOUBLE_COM    3
#define EDGE_SINGLE_COM    4

#define COLOR      clMedGray
#define COLOR_EDGE clScrollBar
#define SPACE_EDGE 40

#define NULL_SECT         -2   //    
#define nMAIN_SECT         0
#define nADD_SECT          1
#define nMESH_SECT         2
#define nEDGE_SECT         3
#define nSPAN_SECT         4  //     
#define nSPAN_KOL_SECT     5  //   
#define nSPAN_SECT_MK      6  //     
#define nSPAN_SECT_MK0     7  //        
#define nLEVEL_SECT        8  //    
#define nMASS              9  //  
#define nPODSTROP_BALKA    10  //   

#define CRAN_CONSOL_RIGHT   -4
#define CRAN_CONSOL_LEFT    -3
#define ZATYAGHKA     -2
#define MAIN_SECT     -1   //      
#define KOLONNA_LEFT   0   //    
#define RIGEL_LEFT     1
#define KOLONNA_RIGHT  2
#define RIGEL_RIGHT    3
#define KOLONNA_RIGEL_LEFT         4
#define KOLONNA_RIGEL_RIGHT        5
#define KOLONNA_RIGEL_LEFT_KOL     6
#define KOLONNA_RIGEL_LEFT_RIG     7
#define KOLONNA_RIGEL_RIGHT_KOL    8
#define KOLONNA_RIGEL_RIGHT_RIG    9
#define KONEK                     10
#define KOLONNA_SPAN              11
#define CONSTR_ELEMENT            12   //  ,   
                                       //      
#define SEGMENT_SECT              13
#define SEGMENT_AT_LEFT           14
#define SEGMENT_AT_RIGHT          15
#define SEGMENT_MAIN_LEFT         16
#define SEGMENT_MAIN_RIGHT        17
#define LEVEL_SECT                18
#define STRET_FACHWERK            19

#define KOLONNA_LEFT_MACRO        20   //   
#define RIGEL_LEFT_MACRO          21   //   
#define KOLONNA_RIGHT_MACRO       22   //   
#define RIGEL_RIGHT_MACRO         23   //   
#define KOLONNA_LEFT_MACRO_0      24   //   
#define RIGEL_LEFT_MACRO_0        25   //   
#define KOLONNA_RIGHT_MACRO_0     26   //   
#define RIGEL_RIGHT_MACRO_0       27   //   
#define BALKA_PODSTROP            28

#define ONE_SPAN_DOWN_NAME  " .     "
#define ONE_SPAN_UP_NAME    "  .     "
#define ONE_SPAN_1_UP_NAME  "  .     "
#define MANY_SPAN_DOWN_NAME ",  .     "
#define MANY_SPAN_UP_NAME   ",  .     "
#define MANY_SPAN_UP_MK_NAME   ",  .     "
#define ARBIT_RAMA_NAME   "  "
#define SEGMENT_RAMA_NAME   "  "
#define MANY_LEVEL_NAME   ", ,  "

#define nameSTYK_LEFT_KOL   "     "
#define nameSTYK_RIGHT_KOL  "     "
#define nameSTYK_LEFT_RIG   "     "
#define nameSTYK_RIGHT_RIG  "     "
#define nameSTYK_LEFT   "    "
#define nameSTYK_RIGHT  "    "
#define nameKONEK       ""
#define nameSPAN_KOL_SECT    "  "
#define nameBALKA_PODSTROP   "  "

#define nameLOCAL       "  ","   "," ","  ", "            ", " ", " ", " ", " ", " ", "       "," ",\
                        "", ",  ", ",  ", ", .. ", ", .. ", \
                        " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " "

#define nameTYPE        "    ","    ","            ","       ", "__", " ", "_ ", "__MK", " ", " ", " ", " ",\
                        "    ","       ","       ","       ","       "

//    -1
#define R1_NIZ_KOL_LEFT     0
#define R1_VERH_KOL_LEFT    1
#define R1_RIG_LEFT         2
#define R1_RIG_KONEK_LEFT   3
#define R1_NIZ_KOL_RIGHT    4
#define R1_VERH_KOL_RIGHT   5
#define R1_RIG_RIGHT        6
#define R1_RIG_KONEK_RIGHT  7
#define R1_STYK_LEFT        8
#define R1_KONEK            9
#define R1_STYK_RIGHT      10

#define BODY                0
#define CONST_LOAD          1
#define SNOW_LEFT           2
#define SNOW_RIGHT          3
#define WIND_LEFT           4
#define WIND_RIGHT          5

#define FORCE               0
#define FORCE_PER_LENGTH    1
#define FORCE_PER_AREA      2
#define MOMENT              3

#define dirCOMPONENTS       0
#define dirALONG            1
#define dirNORMAL           2
#define dirVECTOR           3

#define methUNIFORM         0
#define methTAPER           1
#define methFORCE           0
#define methSNOWREGION      1
#define methWINDREGION      2
#define methFORCE_CRAN      3  //     


#define colorNODE           'n'
#define colorELEM           'e'
#define colorLOAD_GEOM      'f'
#define colorLOAD_KEM       'k'
#define colorCONSTRAINT     'c'
#define colorORIGIN         'o'
#define colorAXIS           'a'
#define colorGEOM           'g'
#define colorGEOM_POINT     't'
#define colorGEOM_LINE      'r'
#define colorLABEL          'l'
#define colorLABEL_H        'h'
#define colorLABEL_POS      'p'
#define colorLABEL_ANGLE    'u'
#define colorPIN            'b'
#define colorMASS           'm'
#define colorWINDOW         'w'
#define colorSHADOW         's'

#define indCREATE           0
#define indMODIFY           1
#define indDELETE           2
#define indRELOAD           3

#define indUN_WEIGHT        0    //   
#define indWEIGHT           1    //  

#define opNULL              ' '
#define opPLUS              '+'
#define opMINUS             '-'
#define opMULT              '*'
#define opDIVIDE            '/'

#define LEN_NAME  47    //       
#define MAX_LEN_ARR 80  //  

#define Load_CNIP  0  // 2.01.07-85*, 1 -  20.13330.2011
#define Load_SP    1  // 2.01.07-85*, 1 -  20.13330.2011

//      
#define   groupNON_DEFINED    0   //   ,   
#define   groupCENT_COMP      1   //  -
#define   groupBEND_COMP      2   //  - 
#define   groupBEND           3   //   
#define   groupCENT_TENS      4   //  - 
#define   groupBEND_TENS      5   //  - 


typedef struct _preferences {
   double max_size_plate;
   double max_size_beam;
   int    n_elem_pol;
   int    n_elem_sten;
   char   PathWork[196];  //     SCAD
   char   index_DelSectMesh;   // 0 - , -1 -  
   char   index_round_thick;
   char   CharDummy[2];
   double Tolerance;
   double Del_Merge;
   double dummy[3];
}  PREFERENCES;

typedef struct _vector {
   double Base_x;
   double Base_y;
   double Base_z;
   double Tip_x;
   double Tip_y;
   double Tip_z;
}  VECTOR;

typedef struct _sect_dvutavr {
   double b;      //   
   double h;      //   
   double b1;     //    
   double h1;     //    
   double b2;     //    
   double h2;     //    
   int    n_group;   //   
   int    n_profil;  //    
   int    index_orient;   //  = 0 (  XZ)  1 (  YZ)
   char   type_profil;  //   (DVUTAVR) ,  
   char   index_perfor;  // 0 -   , 1 - 
   char   dummy[2];
   float  fG;
   float  tnom;    //      
   float  b2G;     //    
   float  gG;    //
   bool flag_concl;
}  SECT_DVUTAVR;

typedef struct _sect_gnutic {
   double tG;      //   ()
   double hG;      //  
   double bG;      //  
   double cG;      //  
   double rG;      //  
   double jG;      //  
   int    n_group;   //   
   int    n_profil;  //    
   int    index_orient;   //  = 0 (  XZ)  1 (  YZ)
   char   type_profil;  //   (DVUTAVR) ,  
   char   index_perfor;  // 0 -   , 1 - 
   char   dummy[2];
   float  fG;      //  
   float  tnom;    //      
   float  b2G;     //    
   float  gG;      //   
   bool flag_concl;
}  SECT_GNUTIC;

typedef struct _sect_square {
   double thickness;  //  
   double side;       //  
   double b1;   //  
   double h1;   //  
   double b2;   //  
   double h2;   //  
   int    n_group;   //    -  h*b
   int    n_profil;  //     -  t
   int    index_orient;   //  = 0
   int    type_profil;
   double rad;
   double t_red;
   bool flag_concl;
}  SECT_SQUARE;

typedef struct _sect_rect {
   double b;      //  
   double h;      //  
   double b1;     //    
   double h1;     //    
   double b2;     //  
   double h2;     //  
   int    n_group;   //    -  h*b
   int    n_profil;  //      -  t
   int    index_orient;   // : 0 -  ; 1 -  
   int    type_profil;
   double rad;
   double t_red;
   bool flag_concl;
}  SECT_RECT;

typedef struct _sect_rect_solid {
   double b;      //  
   double h;      //  
   double b1;     //  
   double h1;     //  
   double b2;     //  
   double h2;     //  
   int    n_group;   //   
   int    n_profil;  //    
   int    index_orient;   //  = 0
   int    type_profil;
   double dummy_double[2];
   bool flag_concl;
}  SECT_RECT_SOLID;

typedef struct _sect_circ {
   double thickness;  //  
   double diameter;   // 
   double b1;         //  
   double h1;         //  
   double b2;         //  
   double h2;         //  
   int    n_group;   //   
   int    n_profil;  //    
   int    index_orient;   //  = 0
   int   type_profil;
   double dummy;
   double t_red;
   bool flag_concl;
}  SECT_CIRC;

typedef union _common_sect {   //    
   SECT_DVUTAVR dvutavr;
   SECT_SQUARE  square;
   SECT_RECT    rect;
   SECT_CIRC    circ;
   SECT_RECT_SOLID rect_solid;
}  COMMON_SECT;

typedef struct _data_sect_scad {   //     
   int  type_sect;
   COMMON_SECT com_sect;
}  DATA_SECT_SCAD;

typedef struct _comgen_new {  //    
   char   name_rama[48];
   int    type_rama;          //   (ONE_SPAN_DOWN, ONE_SPAN_DOUBLE_UP, ONE_SPAN_SINGLE_UP, MANY_SPAN_DOWN, MANY_SPAN_UP
   bool   simm;               //   
   double span;               // 
   double x_konek;            //   X
   double z_konek;            //   Z
   double left_kolonna;       //     
   double left_z_rigel;       //    
   double left_z_kolonna;     //    
   double left_uklon;         //     %
   double right_kolonna;
   double right_z_rigel;
   double right_z_kolonna;
   double right_uklon;
   double step_rama;          //  ;
   int n_main_sect;           //   
   int n_add_sect;            //   
   char index_profil_rigel;
   char index_profil_kolonna;
   char index_profil_segment;
   char index_profil_kolonna_inter;
   char index_fachwerk;       // 1 - , 0    -   
   char dummy_char[3];
   short dummy_short;
   short n_macro;
   char flag_auto_pin;
   char flag_auto_constr;
   short n_group_sect;        //   
   int n_edge;                //   
   int n_mesh_sect;           //    
   char n_arbit_load;         //    
   char n_cran;               //  
   char n_cran_comb;          //   
   char n_cran_load;          //    
   char cent_lean[4];         //        2,3,5 : "NT"
   double zat_a_b[2];         //  .  zat_a_b[0]<=0 -   , a=ABS(zat_a_b[0])
   double gamma_n;            //    
   char index_flex_rigel;     //  -     (1),  - 0   
   char  index_pattern_main;  // 1:     - , 0:   
   char n_tipical_load;       //   
   char index_Load_and_Action;  // 0 -  2.01.07-85*, 1 -  20.13330.2011
   short n_edge_left;         //       
   short n_edge_right;        //       
}  COM_RAMA;

typedef struct _add_param_rama {  //   
   double  Shift_opora;            //      : shift > 0 -  
   double  Shift_opora_right;      //      : shift > 0 -  
   char    release_rig[16];            //    [0] - 0  1 , [1] - 1  2 ,  .. 0 - , 1 - 
   char    release_kol[16];            //       [0] - 0  1 , [1] - 1  2 ,  .. 0 - , 1 - 
   int     n_long_edge;                //    
   bool    flag_lock;                  //     
   bool    flag_fileScad;              //    SCAD
   short   index_result;               //   (0 - , 1 - SCAD)
   short   nnuz_origin;
   short   nnel_origin;
   short   gran;                         // 0 -     ; 1 -    
   bool    flag_hing_kol_rig;          //       
   bool    flag_single_uklon;          //   
   double  left_kol_uklon;             //    -1  %   (>0 - )
   double  right_kol_uklon;            //    -1  %   (>0 - )
   bool    flag_kol_level[16];         // true -     , false - 
}  ADD_PARAM_RAMA;

typedef struct _add_span {    //   
   char   sign_sect_kol[8];   //   
   char   sign_sect_rig[8];   //   
   double x_span;           //    
   double l_span;           //  
   double z_kolonna;        //   
   double pos_sect;         //   (  Get_base_sect_MD_plate   Mesh_planP_ManyDown)
   int type_section;        //   
   int    n_edge;           //  
   double b_edge;           //    
   float  t_edge;           //  
   short  type_edge;        //  
   short  group_sect;       //     
   COMMON_SECT sect_kol;    //     ( -   type_section)
   COMMON_SECT sect_rig;    //        ( - dvutavr)
}  ADD_SPAN;

typedef struct _add_span_mk {  //          ( 27.08.2011)
   char   sign_sect_konek[8];  //     
   double x_konek;             //      
   double pos_konek;           //   
   double left_uklon;          //    
   double right_uklon;         //    
   double z_up_kolonna;        //   
   double pos_left;            //     
   double pos_right;           //     
   int    index_right;         //          (0  1)
   short  group_sect;
   short  short_dummy;
   double dummy[3];
   SECT_DVUTAVR sect_konek;      //        ( - dvutavr)
}  ADD_SPAN_MK;

typedef struct _data_sect {   //      
   char     title_sect[34];
   short    type_section;     //   (DVUTAVR, ...
   short    i_span;
   short    i_level;
   char     sign_sect[8];
   short    local_sect;   //   -     
   short    group_sect;   //  ,    ,  -1
   double pos_sect;       //  
   SECT_DVUTAVR section;
}  DATA_SECT;

typedef struct _data_sect_com {   //     
   char   title_sect[36];
   short  i_span;
   short  i_level;
   char   sign_sect[8];
   short    local_sect;   //   -     
   short    group_sect;   //  ,    ,  -1
   double pos_sect;     //  
   int type_section;        //   
   COMMON_SECT section;
}  DATA_SECT_COM;

typedef struct _data_edge {   //   
   char title_sect[36];
   int  dummy[2];
   short  i_span;
   short  i_level;
   bool flag_concl;
   bool flag_double;      //   : true - 
   bool flag_all;         //     : true -    
   int    local_sect;     //   -     
   int    pos_common;     //     -     (0)    (1)
   int    pos_single;     //    -   Y>0 (0)   Y<0 (1)
   double pos_sect;       //  
 // double h1;             //   1   
   double h_stenki;       //      
 //  double h2;             //   2    
   double b_edge;
   double t_edge;
   double h_edge;
   float  pos_edge_norm;  //      
   float  t_pop;          //   
}  EDGE_PARAM;

typedef struct _data_long_edge {   //    
   char title_sect[36];
   int  dummy[2];
   short  i_span;
   short  i_level;
   bool flag_concl;
   bool flag_double;      //   : true - 
   bool flag_all;         //     : true -    
   int    local_sect;     //   -     
   int    index_polka;      //    (0),   (1)
   int    index_single;     //    -   Y>0 (0)   Y<0 (1)
   double pos_polka;       //      (  )
   int    index_pos_left;  //    (-1   ,  KOLONNA_RIGEL_LEFT_RIG || KOLONNA_RIGEL_RIGHT_RIG)
   int    index_pos_right; //    (-1   ,  KOLONNA_RIGEL_LEFT_KOL || KOLONNA_RIGEL_RIGHT_KOL)
   double pos_sect1;      //   
   double pos_sect2;      //   
   double length;         //  
   double b_edge;         //  
   double t_edge;         //  
}  LONG_EDGE_PARAM;
//#define KOLONNA_RIGEL_LEFT_KOL     6
//#define KOLONNA_RIGEL_LEFT_RIG     7
//#define KOLONNA_RIGEL_RIGHT_KOL    8
//#define KOLONNA_RIGEL_RIGHT_RIG    9

typedef struct _data_mesh_sect {   //    
   char   title_sect[36];
   int    dummy[2];
   short    i_span;
   short    i_level;
   bool   flag_concl;
   int    local_sect;     //   -     
   double pos_sect;       //  
   double h_stenki;       //      
}  MESH_SECT_PARAM;


typedef struct _pos_sect {  //   
   //char title[48];
   //int local;
   //double pos;
   int    n_type_sect;      //   
   int    ID_sect;          //    
   int    k_sect;           //    point_corners
}  POS_SECT;


typedef struct _option_draw {  //  
   int    node [3];    // [0]- 0/1 ( /) [1] - 0/1 ( / ) [2] -0/1 (/)
   int    element[3];
   int    load_geom[3];
   int    load_kem[3];
   short  constraint[3];
   short  pin[3];
   short  geometry[4];
   char   mass[3];
   char   send_mark;
   short  geom_point[3];
   short  geom_line[3];
   short  origin[3];
   short  axis[3];
   char  cl_node[3][16];
   char  cl_element[3][16];
   char  cl_load_geom[3][16];
   char  cl_load_kem[3][16];
   char  cl_constraint[3][16];
   char  cl_origin[3][16];
   char  cl_axis[3][16];
   char  cl_geometry[3][16];
   char  cl_label[3][16];
   char  ind_Render;
   char  ind_Volume;
   TColor   cl_shadow[2];
   int   dummy_int[6];
   short  label_H[2];
   short  label_pos[3];
   short  label_Prolet[3];
   short  label_Angle[3];
   short  title_result[3];    //  
   short  scale_contour[3];   //  
   char cl_label_H[3][16];
   char cl_label_pos[3][16];
   char cl_deformed[3][16];
   char cl_label_Angle[3][16];
   char  cl_geom_point[1][16];
   char  cl_pin[2][16];
   char  cl_geom_line[1][16];
   char  cl_mass[2][16];
   char cl_window[16];
}  OPTION_DRAW;


#define LOAD_CONTROL           2.08
typedef struct _data_load_set  {//    

   double karniz;               //  
   double parapet;              //  
   double vert_kol;             //    
   double vert_rig;             //    
   double average_temp;         //   
   int snow_region;             //  
   int wind_region;             //  
   int type_region;             //  
   double Level_ground;         //   . 0.0
   double gamma_f;              //     
   float  freq_1;               //   
   float  freq_2;               //   
   double koeff_snow;           //    
   short  index_PerLength;
   short  group_excl_snow;      //         (   20 ?)
   float  pos_torec;            //     
   double gamma_f_g;            //       
   double gamma_f_c;            //     
   double gamma_f_s;            //     
   double koeff_snow_def;       //         
   short  n_const_level;
   short  n_add_const_level;
   short  n_const_level_res;
   short  index_torec_wind;     //    0 -   , 1 -  , 2 -   ()
   double gamma_f_l;            //       
   short  n_add_const;          //       
   short  n_add_snow_left;      //        
   short  n_add_snow_right;     //        
   short  index_const_load;     //  (0)   (1)  
   bool   flag_w0;              //       w0
   bool   puls_var;             //     0 -   , 1 -   
   short  const_BL;             //     ;               //
   short  index_koeff_ce;       //     (0 -  , 1 )
   short  index_kol_wind;       //    0 -   , 1 -  , 2 -  
   double koeff_weight;         //   -   : koeff + gx, gy, gz    (-1.2, 0,0, 9810) (=*  ).
   float  delta_h;              // Delta_h   h
   float koeff_ct;
   float V_cold;
   float d_size;                //    ()
   float w0;                    //    
   float dummy_2;               
   short n_const;               //    
   bool  flag_reduce_snow;      //      
   bool  flag_puls;             //   
   short n_snow_left;             //     
   short n_snow_left_res;             //     
   short n_snow_right;            //     
   short n_snow_right_res;            //     
   short n_wind_left;             //     
   short n_wind_left_res;             //     
   short n_wind_right;            //     
   short n_wind_right_res;            //     
   double control;              //  : LOAD_CONTROL
}  LOAD_SET;

typedef struct _par_load  {//  ,    

   char name[40];            // 
   double gamma_f;           //  
   int type;                 //  
   int group_same;           //    
   int group_excl;           //    ,  0
   int accompany[5];         //   ,  -1
   double koeff_1;           //  -1
   double koeff_2;           //  -2
   bool flag_crane;        //   
   bool flag_brake;        //    
}  PAR_LOAD;

typedef struct _data_arbit_load  {//    

   char name[40];            // 
   double gamma_f;           //  
   short type;               //  
   char index_geom;          //         (0 -  , 1 -  )
   char dummy;
   int group_same;           //    
   int group_excl;           //    ,  0
   int accompany[5];         //   ,  -1
   double koeff_1;           //  -1
   double koeff_2;           //  -2
   int num_plan;             //  
}  LOAD_SET_ARBIT;

typedef struct _data_force {   //   (  )
   int    option_load;               //  
   short  ref_pos_sectA;             //    Pos_Sect
   short  ind_sectA;                 // -1:   ; 0:   ; 1:   
   short  ref_pos_sectB;             //    Pos_Sect
   short  ind_sectB;                 // -1:   ; 0:   ; 1:   
   int    local_load;
   double length;                    //  
   int    flag_dir;                  //    
   short  flag_method;               //   : methForce || methSNOWREGION || methWINDREGION
   bool   flag_preview;              //
   bool   flag_dummy;               //
   float posA;                      //   
   float posB;                      //   
   float excentr;                   //    
   short   i_span;                  //     
   short   i_level;                  //     
   double Parapet;
   double Karniz;
   double step_rama;                 //  ,         
   double load_A;                    //     
   double load_B;                    //     
   double coorA[3];
   double coorB[3];
   double direction[3];              // ,    : Px, My, Pz
}  LOAD_FORCE;

typedef struct _data_constraint {   //   
   int    ref_pos_sect;             //    Pos_Sect
   int    local;
   bool   constr[6];                //     
   double coor[3];
}  CONSTRAINT;

typedef struct _constr_rama {    //    
   int    node_left;             //   
   char   constr_left[7];        //   
   int    node_right;            //   
   char   constr_right[7];       //   
   int    node_add[MAX_PLAN_CONSTRAINT];         //  
   char   constr_add[7];
   int    element_release[MAX_PLAN_CONSTRAINT];    //      
   int    node_release[MAX_PLAN_CONSTRAINT];     //    (1  2)    
   char   release[7];
}  CONSTR_RAMA;

typedef struct _geom_param_sect {   //    
   double Ar;
   double Izz;
   double Iyy;
   double Iyz;
   double Itor;
   double Hsect; //   (  Z)
   double Wsect; //   (  Y)
   double Zct;   //  ..    
   double Yct;   //  ..      Yct = Wsect/2 (  )
   double Ze;    //       
   double Ye;    //       
   double ky;    //      Y
   double kz;    //      Z
   double point_stress[4][2]; //     (   NASTRAN)
   double z_tau[3]; //  Z     ( .)
   double Sx[3]; //       
   double Sy[3]; //       
   double Hp;    //   .. 
   double Zp;    //  ..   ..  
   double Rad;   //        
   double alfa;  //    Y   
   double I1;    //   
   double I2;    //    
   double Iw;    //   
   double Wx_f;  //    ,    
   double Wx_pl; //    
   double Wu_max;
   double Wu_min;
   double Wv_max;
   double Wv_min;
   int    index_orient;  //   0 -  . XZ; 1 -  . YZ
}  GEOM_PARAM_SECT;

typedef struct _stress_param_sect {   //     
   double sigma_ext;
   double sigma_w_ext; //         
   double sigma_int;
   double sigma_w_int; //         
   double sigma_ct;    //       
   double Hsect;       //  
   double Zct;         //  ..    
   double z0;         //  sigma=0,    
}  STRESS_PARAM_SECT;

typedef struct _export_scale {   //   
   double line;   //   
   double sect;   //  
   double ro_g;   //  *__
   double ro;     //  
   double modules;  //     
   double force;    //  
}  EXPORT_SCALE;

typedef struct _export_dimension {   //      SCAD
   double line;
   double sect;
   double force;
   char   text_line[4];
   char   text_sect[4];
   char   text_force[4];
}  EXPORT_DIMENSION;


typedef struct _base_point {   //    
   double kolonna_down_ext_left[2];
   double kolonna_down_int_left[2];
   double kolonna_up_ext_left[2];
   double kolonna_up_ext_right[2];
   double rigel_kol_ext_left[2];
   double rigel_kol_ext_right[2];
   double rigel_konek_ext_left[2];
   double rigel_konek_ext_right[2];
   double intersect_kol_rig_ext_left[2];
   double intersect_kol_rig_int_left[2];
   double intersect_konek_ext[2];
   double intersect_konek_int[2];
   double kolonna_doun_ext_right[2];
   double kolonna_doun_int_right[2];
   double intersect_kol_rig_ext_right[2];
   double intersect_kol_rig_int_right[2];
}  BASE_POINT_RAMA;

typedef struct _destination {   //     
   bool message;
   bool file;
   bool report;   //     
   AnsiString Name_File;
   FILE *stream;
}  LIST_DEST;

typedef struct _comgen_n {  //    
   char   name_rama[24];
   int    type_rama;
   bool   simm;
   double span;
   double x_konek;
   double z_konek;
   double left_kolonna;  //    
   double left_z_rigel;  //   
   double left_z_kolonna;  //   
   double left_uklon;
   double right_kolonna;
   double right_z_rigel;
   double right_z_kolonna;
   double right_uklon;
   int n_main_sect;     //   
   int n_add_sect;      //   
   int n_sect_kolonna_right;
   int n_sect_kolonna_left;
   int n_sect_rigel_right;
   int n_sect_rigel_left;
   int n_edge;           //   
   int n_mesh_sect;      //    
   int n_load_set;       //   
   int dummy[9];
}  COM_RAMA_new;  //     

typedef struct _var_analysis {
   int    n_base;     //   
   char   var_name[SIZE_VAR_NAME];  //  
   double var_koeff[MAX_VAR_SET];  //   
}  VAR_ANALYSIS;    //    

typedef struct _param_joint {  //  
   char      title_sect[35];  //  
   char      index_cont;     // 0 -    ; 1 -    ; 2 -  
   short     i_span;
   short     simm_joint;  //      JOINT_PARAM  -1
   char      sign_sect[8];    //  
   short     type_sect;       //    (  )
   short     group_sect;      //   
   short     index_sect;      // (   point_corners?) : ID_sect -     
   short     index_sect2;     //     
   short     local_sect;      //  
   short     i_level;         //  
   double    pos_sect;        //  
   double    h_sect;          //    
   double    angle_sect;      //       (YZ)
   double    angle_ext_l;     //        
   double    angle_ext_r;     //        
   double    angle_int_l;     //        
   double    angle_int_r;     //        
}  JOINT_PARAM;

typedef struct _send_mark {  //  
   char      title[36];  //  
   char      sign[8];    //  
   short     n_s1;       //      Joint_ass
   short     n_s2;
}  SEND_MARK;

/*
int String_double(AnsiString field,AnsiString string, double * number);
int String_double_plus(AnsiString field, AnsiString string, double * number);
int String_double_zero_plus(AnsiString field, AnsiString string, double * number);
int String_double_plus_low(AnsiString field, AnsiString string, double value, double * number);
int String_double_zero_low(AnsiString field, AnsiString string, double value, double * number);
int String_double_zero_plus_low(AnsiString field, AnsiString string, double value, double * number);
int StringInt_plus_low(AnsiString field, AnsiString string, int value, int *number);


void Get_param_sect(SECT_DVUTAVR* section, GEOM_PARAM_SECT *param_sect);
void Get_param_sect_comm(int type,COMMON_SECT* section, GEOM_PARAM_SECT *param_sect);
void Get_param_sect_pop(SECT_DVUTAVR* section, double t_pop, double pos_pop, GEOM_PARAM_SECT *param_sect);
*/
int Set_line(int n_line, double *coor1, double *coor2);
int Set_line_norm(int n_line, int n_base, double *coor);
int Get_coor_intersect(int n_line1, int n_line2, double *coor);
int Get_coor_intersect_norm(int n_line, double *coor0, double *coor);
double Get_intersect(int n_line1, int n_line2, int line_intersect);
int Set_line_paral(int n_line, int n_base, double abs_delta, double *coor);

int Get_Sect_Param(int local_pos, double position, DATA_SECT *sect_at_edge, int *m_base, int *m_add, bool flag_expand);
int Get_Sect_Param_MK(int i_span, int local_pos, double position, DATA_SECT *sect_at_edge, int *m_base, int *m_add, bool flag_expand);
int Get_Sect_Param_MK_level(int i_span, int i_level, int local_sect, double pos_sect, DATA_SECT *sect_at_edge, int *m_sect_base, int *m_sect_add, bool flag_expand);
void  Point_dvutavr(int zero, int zero1, int zero2, SECT_DVUTAVR *sect, float scale, TPoint *vertices);

int EdgeParamToType(EDGE_PARAM *edge);
int Get_m_base(int n1, int n2, int m1, int m2, double *coor_edge, double* pos_edge);
double Calc_h_sect(DATA_SECT *sect, double **point_corners, int n1, int n2);

int Get_base_sect_Down(int *n_point_corners, double** point_corners, DATA_SECT *sect_node,
                   double **coor0, int *num_point_corners, int *i_sect0);
int Get_base_sect_Down_plate(int *n_point_corners, double** point_corners, DATA_SECT *sect_node,
                   double **coor0, int *num_point_corners, int *i_sect0, bool flag_expand);
int Get_base_sect_Down_plate0(int *n_point_corners, double** point_corners, DATA_SECT *sect_node,
                   double **coor0, int *num_point_corners, int *i_sect0, bool flag_expand);
int Get_base_sect_Up(int *n_point_corners, double** point_corners, DATA_SECT *sect_node,
                   double **coor0, int *num_point_corners, int *i_sect0);
int Get_base_sect_Up_1(int *n_point_corners, double** point_corners, DATA_SECT *sect_node,
                   double **coor0, int *num_point_corners, int *i_sect0);
int Get_base_sect_MD(int *n_point_corners, double** point_corners, DATA_SECT *sect_node,
                   double **coor0, int *num_point_corners, int *i_sect0);
int Get_base_sect_MD_plate(int *n_point_corners, double** point_corners, DATA_SECT *sect_node,
                   double **coor0, int *num_point_corners, int *i_sect0, bool flag_expand);
int Get_base_sect_MD_plate0(int *n_point_corners, double** point_corners, DATA_SECT *sect_node,
                   double **coor0, int *num_point_corners, int *i_sect0, bool flag_expand);
int Get_base_sect_ManyUp(int *n_point_corners, double** point_corners, DATA_SECT *sect_node,
                   double **coor0, int *num_point_corners, int *i_sect0);
int Get_base_sect_ManyUp_MK(int *n_point_corners, double** point_corners, DATA_SECT *sect_node,
                   double **coor0, int *num_point_corners, int *i_sect0);
int Get_base_sect_Arbit(int *n_point_corners, double** point_corners, DATA_SECT *sect_node,
                   double **coor0, int *num_point_corners, int *i_sect0);
int Get_base_sect_Arbit_Only();                   

void Get_point_corners(int *n_point, double **point_corners);
void Get_point_corners_plate(int *n_point, double **point_corners);
void Get_point_corners_Up(int *n_point, double **point_corners);
void Get_point_corners_Up_plate(int *n_point, double **point_corners);
void Get_point_corners_Up_1(int *n_point, double **point_corners);
void Get_point_corners_Up_1_plate(int *n_point, double **point_corners);
void Get_point_corners_ManyUp(int *n_point, double **point_corners);
void Get_point_corners_ManyUp_plate(int *n_point, double **point_corners);
void Get_point_corners_ManyUp_MK(int *n_point, double **point_corners);
void Get_point_corners_ManyUp_plate_MK(int *n_point, double **point_corners);

void Get_coor_point(int k1, int k2, double ** point_corners, GEOM_PARAM_SECT *param_sect, double **coor,
                    int i_sect, int *num_point_corners);
void Get_point_add(int n1, int n2, double pos_sect, double factor, GEOM_PARAM_SECT *param_sect, double **point_corners, int *n_point);
void Get_point_add_level(int i_level, double pos_sect, double factor, DATA_SECT *sect, double **point_corners,
                   int *n_point);
//    
void Get_point_add_plate(int n1, int n2, double pos_sect, double factor, DATA_SECT *sect, double **point_corners,
                   int *n_point);
//     
void Get_point_add_span_plate(int i_span, double pos_sect, DATA_SECT *sect, double **point_corners,
                   int *n_point);
void prinm0(char *str, int m, int n, double **mat);
void prinm_G(char *str, int m, int n, double **mat);   //    g
void prinm_i(char *str, int m, int n, int **mat);  //    
void prinm_f(char *str, int m, int n, float **mat);

void Expand(double *coor10, double *coor11, double *coor20, double *coor21, double *coor0);

int Def_closed_point(int local_sect, int n1, int n2, double ** point_corners, int *num_point_corners, DATA_SECT *sect_node );
int Def_closed_point_add(int local_sect, int n1, int n2, double ** point_corners, int *num_point_corners, DATA_SECT *sect_node );
int Def_closed_point_MK(int i_span, int local_sect, int n1, int n2, double ** point_corners, int *num_point_corners, DATA_SECT *sect_node );
int Def_closed_point_add_MK(int i_span, int local_sect, int n1, int n2, double ** point_corners, int *num_point_corners, DATA_SECT *sect_node );

int Alloc_mesh();
int Free_mesh();
int Alloc_elem(int nuz, int nelem);
int Get_point_for_norm_edge(int n0, int n1, int nk, int nr, double pos_sect, double **point_corners, int *n_point_corners,
                             int *n_point_norm_edge);
int Get_coor_pos_min(int n1, int n2, int m1, double **point_corners, double pos_sect, double *coor_edge, double *pos_2, double *pos_min);
int Get_coor_pos(int n1, int n2, double **point_corners, double pos_sect, double *coor_edge, double *pos_2);
int Get_coor_pos_norm(int n1, int n2, double **point_corners, double pos_sect, int k1, int k2,
                      double *coor_edge, double *length, double *pos_2);
double Calc_distance(double **point_corners, int n1, int n2);
int Diag_coincident_edge();
int Diag_coincident_mesh_sect();
int Get_coor_point_pos(double *coor1, double *coor2, double pos_sect, double *coor_point);
int Get_coor_point_pos_un(double *coor1, double *coor2, double pos_point, double *coor_point);

double Get_coor_length(double *coor1, double *coor2);
double Get_coor3_length(double *coor1, double *coor2);
int Get_delta(int n_line, double *coor, double *delta);
int Get_tang(int n_line, double dx, double dy, double *tang);
int Get_angle(int n_line1, int n_line2, double *angle);
int Get_angle_vector(int n_line, double dx, double dy, double *angle);
int Get_angle_coor(double *coor0, double *coor1, double *coor2, double *angle);
int Get_coor_mirror(double *point1, double *point2, double *coor, double *coor_m);

int draw_all();
int draw_mesh();
int draw_geom();
int draw_skelet();

void Set_Frame(bool flag_frame, int X0, int Y0, int X1, int Y1);
int Check_local_sect (int local_sect, double pos_sect);
int Check_local_sect_MK (int i_span, int local_sect, double pos_sect);
int SetNout(bool flag_all, char*elemout, char* nodeout, int*ElemOut, int* Ne);
int Alloc_macro();

void Get_DirNormal(double *coor_face0, double *coor_face1, double factor, double *direction);
void Get_coor_L(double *coor_L, double *coor_face0, double *coor_face1, double pos, double length_face);
int Get_Pos_Sect_local(int i);
double Get_Pos_Sect_pos(int i, double length_face);
//   
double Get_Pos_Sect_pos_on_ref(int ref, double lenght_face);
int Get_Pos_Sect_i_sect(int ID_sect, int type_sect); //           
int Get_Pos_Sect_k_sect(int ID_sect, int type_sect); //           
int Get_pos_for_load(LOAD_FORCE *load);
void Get_span_MK_k_j(int ID_sect, int *k, int * i_span);  //  k_local  i_span   MK
int Get_Pos_Sect_span(int i);
int Get_Pos_Sect_level(int i);
char* Get_Pos_Sect_title(int i);
char* Get_Pos_Sect_title_type_ID(int type_sect, int ID_sect);
double Get_Pos_Sect_H(int i);
int Get_Pos_Sect_type_on_ref(int ref);


int Get_num_from_title(AnsiString title);
int Reflect_local(int ref_pos);
void GetListMater(int nnel, CONT* cont, DSC_MVC *stif, int **Emat, int *number_mat);
int NumMat(int ind_mat, int ind_weight, int* Emat, int number_mat);

int Get_coor_sect(int type, int i_sect,  double **coor_corners, double **coor_sect, SECT_DVUTAVR *sect_p);
int Get_coor_edge(int i_edge, double **coor_corners, double **coor_sect, SECT_DVUTAVR *sect_p);
int Get_coor_sect_num(int i_sect, double **coor_corners, double **coor_sect, SECT_DVUTAVR *sect_p);
void  Set_coorg0(double t_conv[][4], double **coor, int n_coor, double **coorg);
void Get_coorg0_point(double t_conv[][4], double *coor, double z_mod, double scale, double X_shift, double Y_shift);

void  Set_coorg_all(double t_conv[][4], double **coor, int n_coor, double **coorg);
int GetCoorCorners(double** coor_corners);
int Get_Pos_Sect_list_rigel(int index_left, int *index_Pos_sect, int *n_sect_rigel);
int Search_index(int *index_sect, int i_pos, int n_sect);  //   SnowLoad
int ExpandLoadMesh(LOAD_NODAL *load, LOAD_ELEMENTAL *load_el, int *n_load, int *e_load);
int Get_Pos_Sect_list_wind(double level_N0, double level_N1, double level_N2, int *index_Pos_sect, int *n_sect_corners);
double l_app(double *f1, double* f2, double x1, int n);
double l_linap(int npoint, double *y, double step, double xi);

int Get_Sect_wind(int local, double pos, double *pos0);
int Get_Sect_load_MK_level(int i_span, int i_level, int local, double pos);
//      point_coors
int Get_Sect_load_k_sect(int i_span, int i_level, int local, double pos);
int Get_Sect_load_MK(int i_span, int local, double pos);
int GetCreate_Sect_load_MK_level(int i_span, int i_level, int local, double pos, TObject *Sender);
int GetCreate_Sect_load_MK(int i_span, int local, double pos, TObject *Sender);
int Get_Sect_mesh_MK(int i_span, int local, double pos);
void Print_Pos_Sect();
bool ConfirmDelete(AnsiString name);

double Get_span_z_rigel(int ik);
double Get_span_pos_rigel(int ik);
int FormatInt(double x);
int ChangeActiveLoadSet(int k);
int Get_Pos_Sect_Exp(int local_sect, double *min_pos, double *max_pos);
int CheckCoincidentNodes(int nnuz, int nelem, double **coor, int *index_nuz, int **topo_init, double Del_Merge, int n_base_sect);
int CheckCoincidentRigid(int *index_nuz, int *n_rig_l, int *n_rig_r, int *Rigid_node_left, int *Rigid_node_right);
int CheckCoincidentListNodes(int *index_nuz, int *n_nodes, int *List_nodes);
int CoincidentNodes(int nnuz, double **coor, int *index_nuz, double Del_Merge);
int RenumberTopo(int *index_nuz, int nnel, CONT  * cont, DSC_MVC * elem);
int RenumberNode_Load(int *index_nuz, int n_base_sect, DSC_MVC* node_load);

int getcom();
int getver();
int getdrive();
int getsystem();
void GetStroka(double cod, int shift, char* stroka);
void GetMaska(double cod, int *maska, char* maska_symb);
void GetCod(int *pass, char* stroka);
void GetCodX(int *pass, char* stroka);
void GetStrokaX(double cod, int shift, char* stroka);
void No_Mesh();
void Null_Check();
void  Set_coorg_def(double t_conv[][4], double **coor, double **disp_node, double koeff_disp, int n_coor, double ** coorg);
int CheckCoincidentRigKol(int *index_nuz, int i_ren, int *elem_kol, DSC_MVC * topo_kolonna) ;
double mass_macro(int *point_macro, double **Coor_macro, double t_plast);
double mass_Dvutavr(double coor_macro[4][3], SECT_DVUTAVR *sect, int index_pol);

int Pack_stif(int nnel, CONT* cont, DSC_MVC* stif, int *num_stif_elem, DSC_MVC* pack_stif, int *n_pack_stif);
void FormSignSect();
void GetSign(char* sign);
void ChangeSign(char *sign1, char*sign2);
int SetComboBoxList(TComboBox* ComboBox, char* sign);
int Set_for_Sign(TLabel *Label_I, TComboBox* ComboBox_I, TLabel *Label_O, TComboBox* ComboBox_O,
                 bool flag_external);
int  Get_param_beam(double *gt, GEOM_PARAM_SECT *param_sect);
void SortJoint(int N_joint, JOINT_PARAM *Joint_param);
void SortJoint_Index(int N_joint, JOINT_PARAM *Joint_param, int *index_joint);
void Get_point_corners_MD(int *n_point, double **point_corners);
void Get_point_corners_MD_plate(int *n_point, double **point_corners);
double Get_right_uklon_MD(double **point_corners);
double draft_z_span_kol(int ik);
void Set_index_type_element(int local_cect);
int Get_MaterialProperty(double *Ey, double *Ry,  double *density);
void Set_medium_elem(int *kol_elem_third, int *kol_elem_max, int *kol_elem_up);
int Order_nuz_on_elem(int n_elem, int n_node);
double Fun_fi_e(double lambda_r, double m_ef);
double Fun_alfa(double mx);
double Fun_fi(double lambda_r, double Ey, double Ry);
double Fun_beta(double lambda_y, double lambda_c, double fi_y, double fi_c);
double Fun_psi(double alfa_);
double Fun_eta(double A_, double lambda_, double m_, double *eta_work);
double Fun_eta_tavr(double A_, double lambda_, double m_);
double Fun_koef_stab_edge(double Ey, double Ry, double tau_cr, double mu_, double tw, double a_ots, double W_min, EDGE_PARAM *edge);
double Get_span_pos_konek(int ik);
double Get_uklon_right(double a_right, double *point1, double *point2);
void Get_n1_n2_factor_MK(int i_span, int local_sect, int *n1, int *n2, double *factor);
void SumForces(double massa, double *Sum_Force);
int MassFromConstLoad (double *mass_nodal);
void Get_stress(double Mz, double N,  SECT_DVUTAVR *sect, STRESS_PARAM_SECT *stress_sect,
                double H_sect, double h1_min, double h2_min);
void Get_stress_param(double Mz, double N,  GEOM_PARAM_SECT param_sect, STRESS_PARAM_SECT *stress_sect,
                double H_sect, double h1_min, double h2_min);

void Get_load_cons(int k_cran_load, double H_sect, int index, double *L_cons, double *load_cons, double load_rb);
int Set_kolonn_elem_hing(bool flag_simm_reg, int *kol_elem_up, int *rig_elem_up);
void Get_elem_link(int num_elem, int num_end, int *num_linked);

double Get_for_Level_H1(SECT_DVUTAVR *sect0, int index_mesh);   //       
double Get_for_Level_level(double level, SECT_DVUTAVR *sect0, int index_mesh);  //       
//     
void Get_name_load(AnsiString* name_load);


void Long_form_num_sect(int num_long_sect[MAX_EDGE][2]);
int  Long_check_coin_edge(int k1, int k2, int num_long_sect[MAX_EDGE][2]);
void Long_corner(int l10, int l11, int l20, int l21, int n_long, double **point_scale, double coor_corner_long[2][2]);

int   GetElemFromSect(int n_sect, JOINT_PARAM *JointParam, int n_main_sect, int *n_elem, int *n_nuz, bool flag_RSU);
void  GetListSect(AnsiString Caption_select, int *n_sect, TListBox *ListBox_dummy, JOINT_PARAM* ListSect, int *list_sect_int,
                                             int* n_main_sect, double coor_ext[][3]);
// DECLARE
void Get_point_corners_Arbit(int *n_point, double **point_corners);
void Get_point_add_arbit(int n1, int n2, double pos_sect, double *vector, GEOM_PARAM_SECT *param_sect, double **point_corners,
                   int *n_point);
int cmp_load_force(LOAD_FORCE *elem1, LOAD_FORCE *elem2);

void  Show_sect(int n_sect, int n_main, int *list_index_order, int *index_choice);
void  show_main_sect0(int k);
void  show_add_sect0(int k);
int  CopySectDvutavr(SECT_DVUTAVR *sect1, SECT_DVUTAVR* sect2);


#endif
