//---------------------------------------------------------------------------

#ifndef Help_FlexTensH
#define Help_FlexTensH
//---------------------------------------------------------------------------
#include <System.Classes.hpp>
#include <Vcl.Controls.hpp>
#include <Vcl.StdCtrls.hpp>
#include <Vcl.Forms.hpp>
#include <Vcl.Buttons.hpp>
#include <Vcl.Grids.hpp>

#define  Tabl_33_1 "      (  )   "
#define  Koeff_33_1_1   250
#define  Koeff_33_1_2   400
#define  Koeff_33_1_3   250

#define  Tabl_33_2 "    ,     "
#define  Koeff_33_2_1   350
#define  Koeff_33_2_2   400
#define  Koeff_33_2_3   300

#define  Tabl_33_3 "      "
#define  Koeff_33_3_1   0
#define  Koeff_33_3_2   0
#define  Koeff_33_3_3   150

#define  Tabl_33_4 "     (   )"
#define  Koeff_33_4_1   300
#define  Koeff_33_4_2   300
#define  Koeff_33_4_3   200

#define  Tabl_33_5 "  "
#define  Koeff_33_5_1   400
#define  Koeff_33_5_2   400
#define  Koeff_33_5_3   300

#define  Tabl_33_6 "      ,     ,       "
#define  Koeff_33_6_1   250
#define  Koeff_33_6_2   0
#define  Koeff_33_6_3   0

#define  Tabl_33_7 "   ,       ,     6  8"
#define  Koeff_33_7_1   350
#define  Koeff_33_7_2   0
#define  Koeff_33_7_3   0

#define  Tabl_33_8 "       (          ),    ,      "
#define  Koeff_33_8_1   150
#define  Koeff_33_8_2   0
#define  Koeff_33_8_3   0


//---------------------------------------------------------------------------
class THelp_FlexTensForm : public TForm
{
__published:	// IDE-managed Components
	TLabel *Label1;
	TStringGrid *StringGrid_FlexTens;
	TBitBtn *BitBtnCancel;
	TListBox *ListBox1;
	TBitBtn *BitBtn_Apply;
	void __fastcall FormShow(TObject *Sender);
	void __fastcall StringGrid_FlexTensDrawCell(TObject *Sender, int ACol, int ARow,
          TRect &Rect, TGridDrawState State);
	void __fastcall StringGrid_FlexTensSelectCell(TObject *Sender, int ACol, int ARow,
          bool &CanSelect);
	void __fastcall BitBtnCancelClick(TObject *Sender);
	void __fastcall BitBtn_ApplyClick(TObject *Sender);
    void __fastcall Fill_Grid();
private:	// User declarations
public:		// User declarations
	__fastcall THelp_FlexTensForm(TComponent* Owner);
	double Koeff[16][3];
	double Koeff_FlexTens;
	AnsiString Text_FlexTens;
};
//---------------------------------------------------------------------------
extern PACKAGE THelp_FlexTensForm *Help_FlexTensForm;
//---------------------------------------------------------------------------
#endif
