//---------------------------------------------------------------------------
#include <vcl.h>

#pragma hdrstop

#include "Unit2.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
 //----------------------------------------------------------------------------
 //     
void Draw_dvutavr_weld_plane(TImage * Image_stand, SECT_DVUTAVR *sect) {
  TPoint vertices1[30];
  TPoint vertices2[30];
  TPoint vert_rect[30];
  int zero, zero1, zero2;
  double zero_f, zero1_f, zero2_f;
  double scale_1, scale;
  int rc;


	double * ParamProfil;
	int shiftY = SHIFTY;
	int shiftX = SHIFTX;

	TRect NewRect = Rect(0, 0, Image_stand->Width,Image_stand->Height);
	Image_stand->Canvas->Brush->Color = clWhite;
	Image_stand->Canvas->FillRect(NewRect);
	Image_stand->Canvas->Rectangle(0, 0, Image_stand->Width,Image_stand->Height);

	scale=(Image_stand->Width-20)/(1e0*sect->b2);
	scale_1=MIN(scale,(Image_stand->Width - 20)/(1e0*sect->b1));
	scale=MIN(scale_1,(Image_stand->Height- 20)/(1e0*(sect->h + sect->h1 + sect->h2)));

	zero_f = (Image_stand->Height - (sect->h + sect->h1 + sect->h2)*scale)/2;
	zero1_f=(Image_stand->Width - sect->b2*scale)/2;
	zero2_f=(Image_stand->Width - sect->b1*scale)/2;

	zero = zero_f;
	zero1 = zero1_f;
	zero2 = zero2_f;
	//   

	Point_weld_dvutavr(zero, zero1, zero2, sect, scale, vertices1); //    

	Image_stand->Canvas->Brush->Color = COLOR;
	//----------------------------------------------------------------

	//--------------------------------------------
	//  
	Image_stand->Canvas->Brush->Color = clScrollBar;
	Image_stand->Canvas->Polygon(vertices1, 12);

	Image_stand->Canvas->Brush->Style=bsClear;

	//Draw_axes_zero(Image_stand, vPLANE, (vertices1[0].x + vertices1[1].x)/2, (vertices1[0].y + vertices1[7].y)/2);

}
//     
void  Point_weld_dvutavr(int zero, int zero1, int zero2, SECT_DVUTAVR *sect, float scale, TPoint *vertices) {
  double b1c = sect->b1*scale;
  double b1p = 0.5*(sect->b1 + sect->b)*scale;
  double b1m = 0.5*(sect->b1 - sect->b)*scale;
  double b2c = sect->b2*scale;
  double b2p = 0.5*(sect->b2 + sect->b)*scale;
  double b2m = 0.5*(sect->b2 - sect->b)*scale;
  double h1c = sect->h1*scale;
  double h_h1 = (sect->h + sect->h1)*scale;
  double h_2h1 = (sect->h + sect->h1 + sect->h2)*scale;
  double h2c = sect->h2*scale;
  double h_h2 = (sect->h + sect->h2)*scale;
  double h_2h2 = (sect->h + 2*sect->h2)*scale;

  vertices[0] = Point(zero2, zero);
  vertices[1] = Point(zero2 + b1c, zero);
  vertices[2] = Point(zero2 + b1c, zero + h1c);
  vertices[3] = Point(zero2 + b1p, zero + h1c);
  vertices[4] = Point(zero2 + b1p, zero + h_h1);
  vertices[5] = Point(zero1 + b2c, zero + h_h1);
  vertices[6] = Point(zero1 + b2c, zero + h_2h1);
  vertices[7] = Point(zero1, zero + h_2h1);
  vertices[8] = Point(zero1, zero + h_h1);
  vertices[9] = Point(zero2 + b1m, zero + h_h1);
  vertices[10] = Point(zero2 + b1m, zero + h1c);
  vertices[11] = Point(zero2, zero + h1c);
  vertices[12] = Point(zero2, zero);
}

