﻿//---------------------------------------------------------------------------

#ifndef Help_FlexCompH
#define Help_FlexCompH
//---------------------------------------------------------------------------
#include <System.Classes.hpp>
#include <Vcl.Controls.hpp>
#include <Vcl.StdCtrls.hpp>
#include <Vcl.Forms.hpp>
#include <Vcl.Buttons.hpp>
#include <Vcl.Grids.hpp>

#define  Tabl_32_1 "Пояса, опорные раскосы и стойки, передающие опорные реакции:"
#define  Tabl_32_1a "а) плоских ферм, структурных конструкций и пространственных конструкций из труб или парных уголков высотой до 50 м"
#define  Koeff_32_1a "  180 - 60α"
#define  Koeff_32_1a_1   180
#define  Koeff_32_1a_2   60
#define  Tabl_32_1b "б) пространственных конструкций из одиночных уголков, а также пространственных конструкций из труб и парных уголков высотой св. 50 м"
//#define  Koeff_32_1b "  120 - 60α"
#define  Koeff_32_1b_1   120
#define  Koeff_32_1b_2   0

#define  Tabl_32_2 "Элементы, кроме указанных в позициях 1 и 7:"
#define  Tabl_32_2a "а) плоских ферм, сварных пространственных и структурных конструкций из одиночных уголков, пространственных и структурных конструкций из труб и парных уголков"
#define  Koeff_32_2a "  210 - 60α"
#define  Koeff_32_2a_1   210
#define  Koeff_32_2a_2   60
#define  Tabl_32_2b "б) пространственных и структурных конструкций из одиночных уголков с болтовыми соединениями"
#define  Koeff_32_2b "  220 - 40α"
#define  Koeff_32_2b_1   220
#define  Koeff_32_2b_2   40

#define  Tabl_32_3 "Верхние пояса ферм, не закрепленные в процессе монтажа (предельную гибкость после завершения монтажа следует принимать по позиции 1)"
#define  Koeff_32_3 "  220"
#define  Koeff_32_3_1   220
#define  Koeff_32_3_2   0

#define  Tabl_32_4 "Основные колонны"
#define  Koeff_32_4 "  180 - 60α"
#define  Koeff_32_4_1   180
#define  Koeff_32_4_2   60

#define  Tabl_32_5 "Второстепенные колонны (стойки фахверка, фонарей и т.п.), элементы решетки колонн, элементы вертикальных связей между колоннами (ниже балок крановых путей)"
#define  Koeff_32_5a "  210 - 60α"
#define  Koeff_32_5_1   210
#define  Koeff_32_5_2   60

#define  Tabl_32_6 "Элементы связей, кроме указанных в позиции 5, а также стержни, служащие для уменьшения расчетной длины сжатых стержней, и другие ненагруженные элементы, кроме указанных в позиции 7"
#define  Koeff_32_6 "  200"
#define  Koeff_32_6_1   200
#define  Koeff_32_6_2   0

#define  Tabl_32_7 "Сжатые и ненагруженные элементы пространственных конструкций таврового и крестового сечений, подверженные воздействию ветровых нагрузок, при проверке гибкости в вертикальной плоскости"
#define  Koeff_32_7 "  150"
#define  Koeff_32_7_1   150
#define  Koeff_32_7_2   0


//---------------------------------------------------------------------------
class THelp_FlexCompForm : public TForm
{
__published:	// IDE-managed Components
	TLabel *Label1;
	TStringGrid *StringGrid_FlexComp;
	TBitBtn *BitBtnCancel;
	TButton *ButtonApp;
	void __fastcall FormShow(TObject *Sender);
	void __fastcall StringGrid_FlexCompDrawCell(TObject *Sender, int ACol, int ARow,
          TRect &Rect, TGridDrawState State);
	void __fastcall StringGrid_FlexCompSelectCell(TObject *Sender, int ACol, int ARow,
          bool &CanSelect);
	void __fastcall BitBtnCancelClick(TObject *Sender);
	void __fastcall ButtonAppClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
	__fastcall THelp_FlexCompForm(TComponent* Owner);
	double Koeff[16][2];
	double Koeff_FlexComp[2];
  	AnsiString Text_FlexComp;

};
//---------------------------------------------------------------------------
extern PACKAGE THelp_FlexCompForm *Help_FlexCompForm;
//---------------------------------------------------------------------------
#endif
