#ifndef GoutH
#define GoutH
#include <vcl.h>
#define LSTR  101

/*----------------------------------------------------*/
/*   ,                    */
/*----------------------------------------------------*/
typedef struct {
    int  op;    /*   */
    int  type;  /*   */
    double pf;  /*   X 1/0/-1 */
    double py;  /*   Y */
    double xo;  /*    X */
    double yo;  /*    Y */
    double xr;  /*     X */
    double yr;  /*     Y */
    double stx; /*    X */
    double sty; /*    Y */
    double xt;  /*     X */
    double yt;  /*     Y */
    double x0;  /*    X */
    double y00; /*    Y */
    double x;
    double y;
    double hi;  /*   */
    double it;  /*    */
    double an;  /*     */
    double mx;  /*    X */
    double my;  /*    Y */
    double mf;  /*   */
    char  formx[10];  /*     X */
    char  formy[10];  /*     Y */
    char  ei[10];     /*    */
    char  mark[10];   /*   */
    char  nx[20];     /*     X */
    char  gx[20];     /*   */
    char  ny[20];     /*     Y */
    char  nf[20];     /*   */
    char  gf[100];    /*   */
    char  fi[32];     /*    */
    char  str[LSTR];
} NOP;

typedef struct {
   bool type_func;
   double mf;
   char nf[20];
   char gf[30];
   char ei[10];
   char fi[80];
   char mark[2];
   int mark_size;
   int mark_step;
   int mark_shift;
} Func;

void g_mf(NOP* nop);
void g_mout(double x, double y);
void g_str(double x, double y, char *str);
void g_ot(double x, double y);
void g_bot(double x, double y);
void g_cyrc(double rad);
void g_squar();
void g_trian(double ss);
void g_smul();
void g_ssum();
void g_h(double h);
void g_it(double h);
void g_an(double h);
void g_mark(char* m);
void g_type(int type);
int g_pg(NOP * nop);
void sout(char *st);
void four(double x);
int g_rpar(NOP* nop);
int g_fun(NOP* nop);
int g_funt(NOP* nop);
void g_x(NOP* nop);
void g_vir(double t, double y, char* str);
void g_y(NOP* nop);
int g_gr(NOP* nop);
void g_outop(char *form);
void g_outc(char *form, char * str);
void g_oute(char *form, double num);
void g_outi(char * form,int num);
void pAx_X(TMetafileCanvas *pCanvas, NOP* nop);
void pAx_Y(TMetafileCanvas *pCanvas, NOP* nop);
void pSetka(TMetafileCanvas *pCanvas, NOP* nop);
void pFont(TMetafileCanvas *pCanvas, NOP* nop);
void g_mout_(TMetafileCanvas *pCanvas, double x, double y);
void g_ot_(TMetafileCanvas *pCanvas, double x, double y);
void g_bot_(TMetafileCanvas *pCanvas, double x, double y);
void g_vir_(TMetafileCanvas *pCanvas, double x, double y, char *str);
void g_str_(TMetafileCanvas *pCanvas, double x, double y, char *str);
void g_text(double x, double y, char *str);
void g_mout_(TMetafileCanvas *pCanvas, double x, double y);
void g_cyrc_(TMetafileCanvas *pCanvas,double rad);
void g_squar_(TMetafileCanvas *pCanvas);
void g_trian_(TMetafileCanvas *pCanvas,double ss);
void g_smul_(TMetafileCanvas *pCanvas);
void g_ssum_(TMetafileCanvas *pCanvas);
#endif

