//---------------------------------------------------------------------------
#ifndef UnitGrapH
#define UnitGrapH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Buttons.hpp>
#include <CheckLst.hpp>
#include <Dialogs.hpp>
#include <ComCtrls.hpp>
#include <ImgList.hpp>
#include <Menus.hpp>
#include <ToolWin.hpp>
#include "Gout.h"
#include <System.ImageList.hpp>

//---------------------------------------------------------------------------
class TOutGraphicForm : public TForm
{
__published:	// IDE-managed Components
        TLabel *Label1;
        TEdit *Edit_size_X;
        TLabel *Label2;
        TEdit *Edit_size_Y;
        TLabel *Label3;
        TEdit *Edit_step_Y;
        TEdit *Edit_step_X;
        TGroupBox *GroupBox1;
        TGroupBox *GroupBox2;
        TGroupBox *GroupBox3;
        TCheckBox *CheckBox_legend;
        TLabel *Label6;
        TEdit *Edit_t_null;
        TLabel *Label7;
        TEdit *Edit_t_scale;
        TLabel *Label8;
        TEdit *Edit_t_name;
        TLabel *Label9;
        TEdit *Edit_t_pos;
        TLabel *Label10;
        TEdit *Edit_t_format;
        TLabel *Label11;
        TEdit *Edit_Y_null;
        TLabel *Label12;
        TEdit *Edit_Y_scale;
        TLabel *Label13;
        TEdit *Edit_Y_name;
        TLabel *Label14;
        TEdit *Edit_Y_pos;
        TLabel *Label15;
        TEdit *Edit_Y_format;
        TSaveDialog *SaveDialog_Grap;
        TOpenDialog *OpenDialog_GrapData;
        TToolBar *ToolBar1;
        TMainMenu *MainMenu1;
        TMenuItem *N1;
        TMenuItem *NOpen;
        TMenuItem *NSave;
        TMenuItem *NSaveAs;
        TMenuItem *NExport;
        TMenuItem *N6;
        TMenuItem *N7;
        TMenuItem *NLook;
        TMenuItem *N9;
        TMenuItem *NExit;
        TToolButton *ToolButton1;
        TImageList *ImageList1;
        TToolButton *ToolButton2;
        TToolButton *ToolButton3;
        TToolButton *ToolButton4;
        TToolButton *ToolButton5;
        TMemo *Memo1;
        TEdit *Edit_x0;
        TEdit *Edit_y0;
        TLabel *Label16;
        TEdit *Edit_pict_x;
        TEdit *Edit_pict_y;
        TSaveDialog *SaveDialog_EMF;
        TLabel *Label;
        TEdit *Edit_name;
        TGroupBox *GroupBox_Font;
        TComboBox *ComboBox_font;
        TComboBox *ComboBox_height;
        TSpeedButton *SpeedButton_bold;
        TSpeedButton *SpeedButton_italic;
        TCheckBox *CheckBox_Max;
        TMenuItem *N2;
        TMenuItem *N3;
        TMenuItem *N4;
        TSpeedButton *SpeedButton2;
        TSpeedButton *SpeedButton1;
        TSpeedButton *SpeedButton3;
        void __fastcall FormShow(TObject *Sender);
        void __fastcall N12Click(TObject *Sender);
        void __fastcall NExportClick(TObject *Sender);
        void __fastcall NSaveClick(TObject *Sender);
        void __fastcall NSaveAsClick(TObject *Sender);
        void __fastcall NExitClick(TObject *Sender);
        void __fastcall pText(TMetafileCanvas *pCanvas, NOP* nop);
        void __fastcall pFunc(TMetafileCanvas *pCanvas, NOP* nop);
        void __fastcall pAx_X(TMetafileCanvas *pCanvas, NOP* nop);
        void __fastcall pAx_Y(TMetafileCanvas *pCanvas, NOP* nop);
private:	// User declarations

public:		// User declarations
        __fastcall TOutGraphicForm(TComponent* Owner);
        float *x_result;
        float **matr_result;
        int n_fun;
        int n_result;
        int n_text;
        float *x_text;
        float *y_text;
        char  *out_text[240];
};
//---------------------------------------------------------------------------
extern PACKAGE TOutGraphicForm *OutGraphicForm;
//---------------------------------------------------------------------------
#endif
