//---------------------------------------------------------------------------

#ifndef Get_param_sect_gnuH
#define Get_param_sect_gnuH

#include "Data_Gen.h"
typedef struct _geom_param_sect_eff {   //      
   double A_eff;
   double b_eff;
   double I_eff_y;  //      
   double I_eff_z;  //      
   double alfa;
   double I_eff_u;
   double I_eff_v;
   double W_eff_yc;
   double W_eff_yt;
   double W_eff_Umax;
   double W_eff_Umin;
   double W_eff_Vmax;
   double W_eff_Vmin;
   double zc;   //  ..    
   double zt;   //  ..    
}  GEOM_PARAM_SECT_EFF;

//---------------------------------------------------------------------------
void Get_param_sect_gnu(SECT_GNUTIC* section, GEOM_PARAM_SECT *param_sect, bool *flag_rad);
//      
void Get_param_eff_bend(double Ry, double E, SECT_GNUTIC* section, GEOM_PARAM_SECT_EFF *param_sect_eff);
//        
int Get_geom_param_XY(double *X_, double* Y_, double* thick, double hG, int n_seg, GEOM_PARAM_SECT* param_sect);

double get_tabl_4_1(double psi);


#endif
