//---------------------------------------------------------------------------

#ifndef GrapFuncH
#define GrapFuncH

#define LSTR  101
//---------------------------------------------------------------------------
/*----------------------------------------------------*/
/*   ,                    */
/*----------------------------------------------------*/
typedef struct {
    bool flag_scale;    //   
    bool flag_marker;     //   
    bool flag_max_min;  //    
    bool flag_log;      //   
    double pf;  /*   X 1/0/-1 */
    double py;  /*   Y */
    double xr;  /*     X */
    double yr;  /*     Y */
    double stx; /*    X */
    double sty; /*    Y */
    double x0;  /*    X */
    double y00; /*    Y */
    double x;
    double y;
    double pict_x;
    double pict_y;
    int h_font;  //   */
    bool flag_italic;  //  
    double an;  /*     */
    double mx;  /*    X */
    double my[6];  /*    Y */
    double mf;  /*   */
    double Scale_grap;
    char  formx[10];  /*     X */
    char  formy[10];  /*     Y */
    char  NameFont[20];  //  
    char  ei[6][10];     /*    */
    char  mark[10];   /*   */
    char  nx[10];     /*     X */
    char  gx[40];     /*   */
    char  ny[20];     /*     Y */
    char  nf[6][10];     /*   */
    char  gf[6][40];    /*   */
    char  str[LSTR];
} GrapOpt;

//---------------------------------------------------------------------------
class TGrapFunc
{
  private:
  double Scale_grap;
  double bx, by;
  double H0;
  double repy;  /*   Y  X */
  char   marker[6];
  int mark_size;
  double hs, hi;


  public:

  void  pSet(GrapOpt* nop, int n_fun, int n_result, int *index_fun, float *x_result, float **matr_result);
  void  pFunc(TMetafileCanvas *pCanvas, GrapOpt* nop);
  int   g_fun_out(TMetafileCanvas *pCanvas, GrapOpt* nop, int num_fun);
  void  pFont(TMetafileCanvas *pCanvas, GrapOpt* nop);
  void  pText(TMetafileCanvas *pCanvas, GrapOpt* nop);
  void  pSetka(TMetafileCanvas *pCanvas, GrapOpt* nop);
  void  pAx_X(TMetafileCanvas *pCanvas, GrapOpt* nop);
  void  pAx_Y(TMetafileCanvas *pCanvas, GrapOpt* nop);
  void  g_vir_(TMetafileCanvas *pCanvas, double t, double y, char *str);
  void  g_ot_(TMetafileCanvas *pCanvas, double x, double y);
  void  g_bot_(TMetafileCanvas *pCanvas, double x, double y);
  void  g_str_(TMetafileCanvas *pCanvas, double x, double y, char *str);
  void  g_mout_(TMetafileCanvas *pCanvas, double x, double y);
  void  g_cyrc_(TMetafileCanvas *pCanvas,double rad);
  void  g_squar_(TMetafileCanvas *pCanvas);
  void  g_trian_(TMetafileCanvas *pCanvas,double ss);
  void  g_smul_(TMetafileCanvas *pCanvas);
  void  g_ssum_(TMetafileCanvas *pCanvas);

        float *x_result;
        float **matr_result;

        int *index_fun;

        int n_fun;
        int n_result;
        int n_text;
        float *x_text;
        float *y_text;
        char  *out_text[240];

};
#endif
