//---------------------------------------------------------------------------

#ifndef Weld_ParamH
#define Weld_ParamH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Buttons.hpp>
#include <Grids.hpp>
#include <ComCtrls.hpp>
#include <ToolWin.hpp>

typedef struct _weld_param {
   double d_wire;
   double Rwf;
   double Rwz;
   double beta_f;
   double beta_z;
   double gamma_wf;
   double gamma_wz;
   double dummy4;
}  WELD_PARAM;

typedef struct _weld_param_unit {  //   
  bool   flag_weld;
  //        !!!
  double Rwf;
  double Rwz;
  double Rwy;
  double Rws;
  double beta_f;
  double beta_z;
  double gamma_wf;
  double gamma_wz;
} WELD_PARAM_UNIT;

//---------------------------------------------------------------------------
class TWeld_ParamForm : public TForm
{
__published:	// IDE-managed Components
        TGroupBox *GroupBox1;
        TLabeledEdit *LabeledEdit_Rwf;
        TBitBtn *BitBtn_Accept;
        TBitBtn *BitBtn_Exit;
        TLabeledEdit *LabeledEdit_beta_f;
        TLabeledEdit *LabeledEdit_beta_z;
        TLabeledEdit *LabeledEdit_gamma_wf;
        TLabeledEdit *LabeledEdit_gamma_wz;
        TGroupBox *GroupBox2;
        TEdit *Edit_Rwy;
        TLabel *Label_Rwy;
        TGroupBox *GroupBox3;
        TEdit *Edit_Run;
        TLabel *Label_Run;
        TEdit *Edit_Rwz;
        TLabel *Label_Rwz;
        TRadioGroup *RadioGroupVidSvarki;
        void __fastcall BitBtn_AcceptClick(TObject *Sender);
        void __fastcall FormShow(TObject *Sender);
        void __fastcall BitBtn_ExitClick(TObject *Sender);
        void __fastcall WeldParam(short vid_svarki);
        double __fastcall GetParam();


private:	// User declarations
public:		// User declarations
        __fastcall TWeld_ParamForm(TComponent* Owner);
        
        int index_vid_svarki;
};
//---------------------------------------------------------------------------
extern PACKAGE TWeld_ParamForm *Weld_ParamForm;
//---------------------------------------------------------------------------
double Get_Rwz(int n_Mater);
//---------------------------------------------------------------------------
double Get_Rwy(int n_Mater);

#endif
