//---------------------------------------------------------------------------
#include <math.h>

#pragma hdrstop

#include "ReportSelectSteel.h"
#include "Word_Automation.h"
#include "StandartProfil.h"
#include "SelectProfilSect.h"
#include "ProcExt.h"
#include "ListConst.h"
#include "RichReport.h"
#include "CheckExecuteU.h"

static    Variant vTabl;
static    Variant my_tables;
static    Variant my_table;
static TStandartProfil StandartProfil;
static     DATA_SELECT *Ds;

extern TCheckExecute CheckExecute;

void Report_sect_param(int form_profil);
void Report_Rect_sect_param();
void Report_Circ_sect_param();
void Report_centr_tension();
//void Report_Rect_centr_tension();
//void Report_Circ_centr_tension();
void Report_centr_compress();
//void Report_Rect_centr_compress();
//void Report_Circ_centr_compress();
void Report_comp_bending();
void Report_bending();
void Report_tension_bending();
//------------------------------------------------------------------
int Report_Checking() {
  int i, k, rc;

  AnsiString type_section[6] = {" ", " ", " ", " "," ",
								" " };

  Ds = &(SelectProfilSectForm->Data_select);

  //   Word
  Word_Automation.GetActiveWord();
  //  
  rc = Word_Automation.CreateDocument("ProfilSteelSelect.dot");
  if (rc>0)
	 return rc;

  //   
  Word_Automation.this_doc.OleProcedure("Select");
  //     
  Word_Automation.my_selection = Word_Automation.my_word.OlePropertyGet("Selection");
  switch (Ds->form_profil) {
  case DVUTAVR_STAND:  // 
  case PERFOR_BEAM:  //  
	Word_Automation.PasteFilePattern("Select_Ibeam_sect_param.doc", "%FILE_SECT_PARAM");
  break;
  case TRUBA:
	if (Ds->type_profil != typeCIRC) {
	   Word_Automation.PasteFilePattern("Select_Rect_sect_param.doc", "%FILE_SECT_PARAM");
	}
	else {
	   Word_Automation.PasteFilePattern("Select_Circ_sect_param.doc", "%FILE_SECT_PARAM");
	}
  break;
  case DVUTAVR_WELD:  //  
	Word_Automation.PasteFilePattern("Select_Ibeam_sect_param.doc", "%FILE_SECT_PARAM");
  break;
  }
  //    
  Report_sect_param(Ds->form_profil);
  int num_tabl = 2;
  //-----------------------------------------------------------------
  // -
  if (SelectProfilSectForm->TabSheet_KI_CT->TabVisible) {
	switch (Ds->form_profil) {
	case DVUTAVR_STAND:  // 
	case DVUTAVR_WELD:   //  
	case PERFOR_BEAM:    //  
		Word_Automation.PasteFilePattern("Select_Ibeam_centr_tension.doc", "%FILE_CENTR_TENS");
		//Report_centr_tension();
	break;
	case TRUBA:
	  if (Ds->type_profil != typeCIRC) {
		 Word_Automation.PasteFilePattern("Select_Rect_centr_tension.doc", "%FILE_CENTR_TENS");
		 //Report_Rect_centr_tension();
	  }
	  else {
		 Word_Automation.PasteFilePattern("Select_Circ_centr_tension.doc", "%FILE_CENTR_TENS");
		 //Report_Circ_centr_tension();
	  }
	break;
	}
	Report_centr_tension();
	num_tabl ++;
    Word_Automation.PasteTextPattern(IntToStr(num_tabl), "%NUM_TABL_CT");
  }
  else {
	Word_Automation.PasteTextPattern(" ", "%FILE_CENTR_TENS");
  }

  //-----------------------------------------------------------------
  // -
  if (SelectProfilSectForm->TabSheet_KI_CC->TabVisible) {
	 switch (Ds->form_profil) {
	 case DVUTAVR_STAND:  // 
	 case DVUTAVR_WELD:   //  
	 case PERFOR_BEAM:    //  
		Word_Automation.PasteFilePattern("Select_Ibeam_centr_compress.doc", "%FILE_CENTR_COMP");
		//Report_centr_compress();
	 break;
	 case TRUBA:
	  if (Ds->type_profil != typeCIRC) {
		 Word_Automation.PasteFilePattern("Select_Rect_centr_compress.doc", "%FILE_CENTR_COMP");
		 //Report_Rect_centr_compress();
	  }
	  else {
		 Word_Automation.PasteFilePattern("Select_Circ_centr_compress.doc", "%FILE_CENTR_COMP");
		 //Report_Circ_centr_compress();
	  }
	 break;
	 }
	 Report_centr_compress();
	 num_tabl ++;
	 Word_Automation.PasteTextPattern(IntToStr(num_tabl), "%NUM_TABL_CC");
  }
  else {
   Word_Automation.PasteTextPattern(" ", "%FILE_CENTR_COMP");
  }

  //-----------------------------------------------------------------
  // -
  if (SelectProfilSectForm->TabSheet_KI_CB->TabVisible) {
	switch (Ds->form_profil) {
	case DVUTAVR_STAND:  // 
	case DVUTAVR_WELD:   //  
	case PERFOR_BEAM:    //  
	  Word_Automation.PasteFilePattern("Select_Ibeam_compress_bending.doc", "%FILE_COMP_BEND");
	break;
	case TRUBA:
	  if (Ds->type_profil != typeCIRC) {
		 Word_Automation.PasteFilePattern("Select_Rect_compress_bending.doc", "%FILE_COMP_BEND");
	  }
	  else {
		 Word_Automation.PasteFilePattern("Select_Circ_compress_bending.doc", "%FILE_COMP_BEND");
	  }
	break;
	}
	Report_comp_bending();
	num_tabl ++;
	Word_Automation.PasteTextPattern(IntToStr(num_tabl), "%NUM_TABL_CB");
  }
  else {
   Word_Automation.PasteTextPattern(" ", "%FILE_COMP_BEND");
  }
  //-----------------------------------------------------------------
  // 
  if (SelectProfilSectForm->TabSheet_KI_B->TabVisible) {
	switch (Ds->form_profil) {
	case DVUTAVR_STAND:  // 
	  //Word_Automation.PasteFilePattern("Select_Ibeam_bending.doc", "%FILE_BEND");
	  Word_Automation.PasteFilePattern("Report_Ibeam_bending.doc", "%FILE_BEND");
	break;
	case DVUTAVR_WELD:   //  
	  //Word_Automation.PasteFilePattern("Select_Ibeam_bending_weld.doc", "%FILE_BEND");
	  Word_Automation.PasteFilePattern("Report_Ibeam_bending.doc", "%FILE_BEND");
	break;
	case PERFOR_BEAM:    //  
	  Word_Automation.PasteFilePattern("Select_Ibeam_bending_perf.doc", "%FILE_BEND");
	break;
	case TRUBA:
	  if (Ds->type_profil != typeCIRC) {
		 Word_Automation.PasteFilePattern("Select_Rect_bending.doc", "%FILE_BEND");
	  }
	  else {
		 Word_Automation.PasteFilePattern("Select_Circ_bending.doc", "%FILE_BEND");
	  }
	break;

	}
	//-----------------------------------------------------
	Report_bending();
	num_tabl ++;
	Word_Automation.PasteTextPattern(IntToStr(num_tabl), "%NUM_TABL_B");
  }
  else {
   Word_Automation.PasteTextPattern(" ", "%FILE_BEND");
  }
  // -
  if (SelectProfilSectForm->TabSheet_KI_TB->TabVisible) {
	switch (Ds->form_profil) {
	case DVUTAVR_STAND:  // 
	case DVUTAVR_WELD:   //  
	case PERFOR_BEAM:    //  
	  Word_Automation.PasteFilePattern("Select_Ibeam_tension_bending.doc", "%FILE_TENSION_BEND");
	break;
	case TRUBA:
	  if (Ds->type_profil != typeCIRC) {
		 Word_Automation.PasteFilePattern("Select_Rect_tension_bending.doc", "%FILE_TENSION_BEND");
	  }
	  else {
		 Word_Automation.PasteFilePattern("Select_Circ_tension_bending.doc", "%FILE_TENSION_BEND");
	  }
	break;

	}
	Report_tension_bending();
	num_tabl ++;
	Word_Automation.PasteTextPattern(IntToStr(num_tabl), "%NUM_TABL_TB");
  }
  else {
   Word_Automation.PasteTextPattern(" ", "%FILE_TENSION_BEND");
  }

  Word_Automation.PasteTextPattern(IntToStr(Ds->N_plane), "%NUM_PART");
  Word_Automation.PasteTextPattern(IntToStr(Ds->index_class), "%CLASS");

  Word_Automation.PasteTextPattern(AnsiString(Ds->title_material), "%MATERIAL");
  Word_Automation.PasteTextPattern(FloatToStr(Ds->gamma_m), "%GAMMA_M");

  Word_Automation.PasteTextPattern(FloatToStrF(Ds->gamma_c, ffFixed, 15, 2), "%GAMMA_C");
  //------------------------------------------------------------
  switch (Ds->form_profil) {
  case DVUTAVR_STAND:
	Word_Automation.PasteTextPattern(type_section[0], "%TYPE_SECT");
  break;
  case TRUBA:
	if (Ds->type_profil==typeSQUARE)
		Word_Automation.PasteTextPattern(type_section[1], "%TYPE_SECT");
	if (Ds->type_profil==typeRECT)
		Word_Automation.PasteTextPattern(type_section[2], "%TYPE_SECT");
	if (Ds->type_profil==typeCIRC)
		Word_Automation.PasteTextPattern(type_section[3], "%TYPE_SECT");
  break;
  case DVUTAVR_WELD:
	Word_Automation.PasteTextPattern(type_section[4], "%TYPE_SECT");
  break;
  case PERFOR_BEAM:
	Word_Automation.PasteTextPattern(type_section[5], "%TYPE_SECT");
  break;
  }
  if (!Ds->flag_add_limit || Ds->max_height==0 ) {
	Word_Automation.PasteTextPattern("", "%MAX_HEIGHT");
  }
  else
	Word_Automation.PasteTextPattern(FloatToStr(Ds->max_height), "%MAX_HEIGHT");

  if (Ds->form_profil != TRUBA)
	Word_Automation.PasteTextPattern("", "%POLKI");
  else
	Word_Automation.PasteTextPattern("", "%POLKI");

  if (!Ds->flag_add_limit || Ds->max_width==0 ) {
	Word_Automation.PasteTextPattern("", "%MAX_WIDTH");
  }
  else
	Word_Automation.PasteTextPattern(FloatToStr(Ds->max_width), "%MAX_WIDTH");

  Word_Automation.PasteTextPattern(FloatToStr(Ds->Limit_lambda1), "%LAM1");
  Word_Automation.PasteTextPattern(FloatToStr(Ds->Limit_lambda2), "%LAM2");
  Word_Automation.PasteTextPattern(FloatToStr(Ds->Limit_lambda_plus), "%LAM_TENS");

  //-------------------------------------------------------------
  //    
  RichReportForm->RichEditOut->Clear();
  char stroka[1200];
  char strpl[36];
  char s_length[1200];
  char strk1[1200];
  char strk2[1200];
  char str_step[1200];
  char strN[1200];
  char strMx[1200];
  char strMy[1200];
  char strq[1200];
  double N_, Mx, My, Qy, Qx, q_bal;

  RichReportForm->RichEditOut->Lines->Add("*-");
  strcpy(stroka, "");
  strcpy(s_length, "");
  strcpy(strk1, "");
  strcpy(strk2, "");
  strcpy(str_step, "");
  for (i=0; i<Ds->N_plane; i++) {
	sprintf(strpl," | %d", i+1);
	strcpy(stroka+strlen(stroka), strpl);
	sprintf(strpl," |%10.0f", Ds->Length[i]);
	strcpy(s_length+strlen(s_length), strpl);
	sprintf(strpl," |%10.0f", Ds->length_YY[i]);
	strcpy(strk1+strlen(strk1), strpl);
	sprintf(strpl," |%10.0f", Ds->length_XX[i]);
	strcpy(strk2+strlen(strk2), strpl);
	sprintf(strpl," |%10.0f", Ds->step_comp[i]);
	strcpy(str_step+strlen(str_step), strpl);
  }
  RichReportForm->RichEditOut->Lines->Add(AnsiString(stroka));
  RichReportForm->RichEditOut->Lines->Add(" , "+AnsiString(s_length));  //   \u03BC  . XZ";
  RichReportForm->RichEditOut->Lines->Add(L"   . YZ, " + String(strk1));
  RichReportForm->RichEditOut->Lines->Add(L"   . XZ, " + String(strk2));
  if (Ds->form_profil==DVUTAVR_STAND || Ds->form_profil==DVUTAVR_WELD || Ds->form_profil==PERFOR_BEAM)
	RichReportForm->RichEditOut->Lines->Add(L"   , " + String(str_step));

  RichReportForm->RichEditOut->Lines->Add("*-");
  Word_Automation.PasteTable(RichReportForm->RichEditOut, "%TABL_PARAM");

  my_tables = Word_Automation.my_range.OlePropertyGet("Tables");
  //    
  my_table=my_tables.OleFunction("Item", 1);

  //    
  // wdAlignRowLeft = 0;
  // wdAlignRowCentr = 1;
  // wdAlignRowRight = 2;
  // my_table.OlePropertyGet("Rows").OlePropertySet("Alignment", 1);

  //   
  my_table.OleFunction("AutoFormat", 23, true, false,
										 true, true,
										 true, false,
										 true, false, true);

  //  
  RichReportForm->RichEditOut->Lines->Add("*-");
  sprintf(stroka,"|N |Mx *|Qy |My *|Qx |qy /");
  RichReportForm->RichEditOut->Lines->Add(AnsiString(stroka));
  for (i=0; i<Ds->N_plane; i++) {
	sprintf(strpl," |  %d", i+1);
	RichReportForm->RichEditOut->Lines->Add(AnsiString(strpl));
	for (k=0; k<Ds->N_RSU[i]; k++) {
	  sprintf(stroka,"%d|%10.1f|%10.1f|%10.1f|%10.1f|%10.1f|%10.1f",
			  k+1, Ds->RSU[i][k][0], Ds->RSU[i][k][1], Ds->RSU[i][k][2],
				   Ds->RSU[i][k][3], Ds->RSU[i][k][4], Ds->q_bal[i][k]);
	  RichReportForm->RichEditOut->Lines->Add(AnsiString(stroka));
	}
  }
  RichReportForm->RichEditOut->Lines->Add("*-");
  Word_Automation.PasteTable(RichReportForm->RichEditOut, "%TABL_RSU");

  my_tables = Word_Automation.my_range.OlePropertyGet("Tables");
  //    
  my_table=my_tables.OleFunction("Item", 1);

  //    
  // wdAlignRowLeft = 0;
  // wdAlignRowCentr = 1;
  // wdAlignRowRight = 2;
  // my_table.OlePropertyGet("Rows").OlePropertySet("Alignment", 1);

  //   
  my_table.OleFunction("AutoFormat", 23, true, false,
										 true, true,
										 true, false,
										 true, false, true);

  Screen->Cursor = crDefault;



  return 0;
}
//-------------------------------------------------------------------------------
//      (   )
void Report_sect_param(int form_profil) {

  int in, i, k;
  CHECK_ELEM_PARAM_U *Cp;
  DATA_CHECK_U *Dt;

  Dt = &(CheckExecute.Data_check_U);
  Cp = &(CheckExecute.Check_param);

  Word_Automation.PasteTextPattern(SelectProfilSectForm->Name_prof, "%NUM_SECT");
  Word_Automation.PasteTextPattern(FloatToStrF(Cp->hw, ffFixed, 15, 0), "%HW_");
  Word_Automation.PasteTextPattern(FloatToStrF(Cp->hef, ffFixed, 15, 0), "%HEF_");
  Word_Automation.PasteTextPattern(FloatToStrF(Cp->bef, ffFixed, 15, 0), "%BEF");

  double Nmin;

  in = -1;
  for (i=0; i<Cp->n_RSU; i++) {
	if (Nmin > Cp->RSU[i][0]) {
	  Nmin = Cp->RSU[i][0];
	  in= i;
	}
  }
  in = SelectProfilSectForm->nnel_max;
  Word_Automation.PasteTextPattern((AnsiString)Cp->Steel, "%STEEL");
  Word_Automation.PasteTextPattern(IntToStr(in+1), "%NUMEL");
  Word_Automation.PasteTextPattern(FloatToStr(Cp->hsect), "%HSECT");
	//Word_Automation.PasteTextPattern(FloatToStr(Cp->Sect_Elem.com_sect.dvutavr.h +
	//								 2*Cp->Sect_Elem.com_sect.dvutavr.h1), "%HSECT");
  Word_Automation.PasteTextPattern(FloatToStr(Cp->bsect), "%BSECT");
	//Word_Automation.PasteTextPattern(FloatToStr(Cp->Sect_Elem.com_sect.dvutavr.b1), "%BSECT");
  Word_Automation.PasteTextPattern(FloatToStr(Cp->Sect_Elem.com_sect.dvutavr.b), "%TW");
  Word_Automation.PasteTextPattern(FloatToStr(Cp->Sect_Elem.com_sect.dvutavr.h1), "%TB");

  Word_Automation.PasteTextPattern(FloatToStrF(Dt->length_XZ[in], ffFixed, 15, 0), "%LEN_XZ");
  Word_Automation.PasteTextPattern(FloatToStrF(Dt->length_YZ[in], ffFixed, 15, 0), "%LEN_YZ");
  //------------------------------------------------------------------------------------------
  if (Ds->t1==1000)
	 Word_Automation.PasteTextPattern(" "+ FloatToStr(Ds->t0), "%THICK%");
  else
	 Word_Automation.PasteTextPattern(" "+ FloatToStr(Ds->t0) + "  " + FloatToStr(Ds->t1), "%THICK%");
  Word_Automation.PasteTextPattern(FloatToStrF(Cp->Ryn, ffFixed, 15, 0), "%RYN%");
  Word_Automation.PasteTextPattern(FloatToStrF(Cp->Ry, ffFixed, 15, 0), "%RY%");
  Word_Automation.PasteTextPattern(FloatToStrF(Cp->Rs, ffFixed, 15, 0), "%RS%");
  //
  Word_Automation.PasteTextPattern(IntToStr(Cp->nelem), "%NELEM");
  Word_Automation.PasteTextPattern(FloatToStrF(Cp->param_sect.Ar*1e-2, ffFixed, 15, 1), "%AN_");
  Word_Automation.PasteTextPattern(FloatToStrF(Cp->Ad*1e-2, ffFixed, 15, 1), "%AD_");

  Word_Automation.PasteTextPattern(FloatToStrF(Cp->param_sect.Itor*1e-4, ffFixed, 15, 0), "%IT");
  Word_Automation.PasteTextPattern(FloatToStrF(Cp->alfa_f, ffFixed, 15, 2), "%AF_");
  Word_Automation.PasteTextPattern(FloatToStrF(Cp->lambda_uw, ffFixed, 15, 2), "%LAMB_UW");
  Word_Automation.PasteTextPattern(FloatToStrF(Cp->lambda_w, ffFixed, 15, 2), "%LAMB_W");
  Word_Automation.PasteTextPattern(FloatToStrF(Cp->lambda_uf, ffFixed, 15, 2), "%LAMB_UF");
  Word_Automation.PasteTextPattern(FloatToStrF(Cp->lambda_f, ffFixed, 15, 2), "%LAMB_F");
  Word_Automation.PasteTextPattern(FloatToStrF(Cp->lambda_f1, ffFixed, 15, 2), "%LAMB_F1");
  Word_Automation.PasteTextPattern(FloatToStrF(Cp->lambda_f2, ffFixed, 15, 2), "%LAMB_F2");
  Word_Automation.PasteTextPattern(FloatToStrF(Cp->lambdaX, ffFixed, 15, 2), "%LAMBX");
  Word_Automation.PasteTextPattern(FloatToStrF(Cp->lambda_x, ffFixed, 15, 2), "%LAMB_X");
  Word_Automation.PasteTextPattern(FloatToStrF(Cp->lambdaY, ffFixed, 15, 2), "%LAMBY");
  Word_Automation.PasteTextPattern(FloatToStrF(Cp->lambda_y, ffFixed, 15, 2), "%LAMB_Y");

  Word_Automation.PasteTextPattern(FloatToStrF(Cp->fi_x, ffFixed, 15, 2), "%_FI_X");
  Word_Automation.PasteTextPattern(FloatToStrF(Cp->fi_y, ffFixed, 15, 2), "%_FI_Y");
  Word_Automation.PasteTextPattern(FloatToStrF(Cp->cfi_y, ffFixed, 15, 2), "%CFI_Y");
}
//-------------------------------------------------------------------------------
//    -  ()
void Report_centr_tension() {

  int in, i, k;
  CHECK_ELEM_PARAM_U *Cp;
  DATA_CHECK_U *Dt;

  Dt = &(CheckExecute.Data_check_U);
  Cp = &(CheckExecute.Check_param);


  AnsiString Text_coeff;
  for (i=0, k=0; i<SelectProfilSectForm->Data_select.N_check[0]; i++) {
		if (SelectProfilSectForm->Num_prov[0][i]==1) {
		  if (k<9)
			Text_coeff = "%Coeff_0"+IntToStr(k+1);
		  else
			Text_coeff = "%Coeff_"+IntToStr(k+1);
		  if (SelectProfilSectForm->Krit[0][i]>=0) {
			  Word_Automation.PasteTextPattern(FloatToStrF(SelectProfilSectForm->Krit[0][i], ffFixed, 15, 2),
			  Text_coeff);
		  }
		  else {
			Word_Automation.PasteTextPattern("-", Text_coeff);
		  }

		  k++;
		}
  }

}
//-------------------------------------------------------------------------------
//    -  ()
void Report_centr_compress() {

  int in, i, k;
  CHECK_ELEM_PARAM_U *Cp;
  DATA_CHECK_U *Dt;

  Dt = &(CheckExecute.Data_check_U);
  Cp = &(CheckExecute.Check_param);


  AnsiString Text_coeff;
  for (i=0, k=0; i<SelectProfilSectForm->Data_select.N_check[1]; i++) {
		if (SelectProfilSectForm->Num_prov[1][i]==1) {
		  if (k<9)
			Text_coeff = "%Coeff_0"+IntToStr(k+1);
		  else
			Text_coeff = "%Coeff_"+IntToStr(k+1);
		  if (SelectProfilSectForm->Krit[1][i]>=0) {
			  Word_Automation.PasteTextPattern(FloatToStrF(SelectProfilSectForm->Krit[1][i], ffFixed, 15, 2),
			  Text_coeff);
		  }
		  else {
			Word_Automation.PasteTextPattern("-", Text_coeff);
		  }
		  k++;
		}
  }

}
//-------------------------------------------------------------------------------
//    -  ()
void Report_comp_bending() {

  int in, i, k;
  CHECK_ELEM_PARAM_U *Cp;
  DATA_CHECK_U *Dt;

  Dt = &(CheckExecute.Data_check_U);
  Cp = &(CheckExecute.Check_param);


  AnsiString Text_coeff;
  for (i=0, k=0; i<SelectProfilSectForm->Data_select.N_check[2]; i++) {
		if (SelectProfilSectForm->Num_prov[2][i]==1) {
		  if (k<9)
			Text_coeff = "%Coeff_0"+IntToStr(k+1);
		  else
			Text_coeff = "%Coeff_"+IntToStr(k+1);
		  if (SelectProfilSectForm->Krit[2][i]>=0) {
			Word_Automation.PasteTextPattern(FloatToStrF(SelectProfilSectForm->Krit[2][i], ffFixed, 15, 2),
			Text_coeff);
		  }
		  else {
			Word_Automation.PasteTextPattern("-", Text_coeff);
		  }
		  k++;
		}
  }

}
//-------------------------------------------------------------------------------
//      ()
void Report_bending() {

  int in, i, k;
  CHECK_ELEM_PARAM_U *Cp;
  DATA_CHECK_U *Dt;

  Dt = &(CheckExecute.Data_check_U);
  Cp = &(CheckExecute.Check_param);


  AnsiString Text_coeff;
  //-------------------------------------------------------------------------------------
  //  
  if (Cp->index_105==1) {
	 Word_Automation.PasteTextPattern(". 8.2.3   . 9.1.1 . (105)", "%PP_NUM");
	 Word_Automation.PasteFilePattern("Report_Ibeam_bending%Form105.doc", "%FORM_106OR106");
	 if ((ABS(Cp->N_105<0.001)))
	   Word_Automation.PasteTextPattern("0", "%N%");
	 else
	   Word_Automation.PasteTextPattern(Round(Cp->N_105, -3), "%N%");
	 Word_Automation.PasteTextPattern(Round(Cp->beta, 2), "%BETA");
	 Word_Automation.PasteTextPattern(Cp->n_pow, "%N_POW");
	 Word_Automation.PasteTextPattern(Round(Cp->cx, 2), "%CX");
	 Word_Automation.PasteTextPattern(Round(Cp->cy, 2), "%CY");
	 Word_Automation.PasteTextPattern(Round(Cp->Wx_min, 0), "%W_XN");
	 Word_Automation.PasteTextPattern(Round(Cp->Wy_min, 0), "%W_YN");
  }
  else {
	 Word_Automation.PasteTextPattern(". 8.2.1   . (106)", "%PP_NUM");
	 Word_Automation.PasteFilePattern("Report_Ibeam_bending%Form106.doc", "%FORM_106OR106");
	 if ((ABS(Cp->N_<0.001)))
	   Word_Automation.PasteTextPattern("0", "%N%");
	 else
	   Word_Automation.PasteTextPattern(Round(Cp->N_, -3), "%N%");
	 Word_Automation.PasteTextPattern(Round(Cp->y_106, 2), "%Y%");
	 Word_Automation.PasteTextPattern(Round(Cp->x_106, 2), "%X%");
  }
  if (Cp->fi_b <=0.85) {
	 Word_Automation.PasteFilePattern("Report_Ibeam_bending%Calc_fi_b_less.doc", "%CALC_FI_B");
  }
  else {
	 Word_Automation.PasteFilePattern("Report_Ibeam_bending%Calc_fi_b_more.doc", "%CALC_FI_B");
  }
  switch (Cp->index_stab_w) {
  case 0:
	 Word_Automation.PasteFilePattern("Report_Ibeam_bending%Calc_stab_10_1.doc", "%CALC_STAB_10");
	 Word_Automation.PasteTextPattern(Round(Cp->k12, 2), "%KW");
  break;
  case 1:
	 Word_Automation.PasteFilePattern("Report_Ibeam_bending%Calc_stab_10_2.doc", "%CALC_STAB_10");
	 Word_Automation.PasteTextPattern(Round(Cp->sigma_stab_max, 1), "%SIG_STAB");
	 Word_Automation.PasteTextPattern(Round(Cp->sigma_stab_cr, 1), "%SIG_CR");
	 Word_Automation.PasteTextPattern(Round(Cp->tau_stab_max, 1), "%TAU_STAB");
	 Word_Automation.PasteTextPattern(Round(Cp->tau_stab_cr, 1), "%TAU_CR");
	 Word_Automation.PasteTextPattern(Round(Cp->sigma_loc, 1), "%SIG_LOC%");
	 Word_Automation.PasteTextPattern(Round(Cp->sigma_loc_cr, 1), "%SIG_LOC_CR");
  break;
  case 2:
	 Word_Automation.PasteFilePattern("Report_Ibeam_bending%Calc_stab_10_3.doc", "%CALC_STAB_10");
  break;
  case 3:
	 Word_Automation.PasteFilePattern("Report_Ibeam_bending%Calc_stab_10_4.doc", "%CALC_STAB_10");
  break;
  }
  Word_Automation.PasteTextPattern(Cp->A_netto, "%ANET");
  Word_Automation.PasteTextPattern(Cp->Qy, "%QY");
  Word_Automation.PasteTextPattern(Cp->Qx, "%QX");
  Word_Automation.PasteTextPattern(Cp->Sy, "%SY%");
  Word_Automation.PasteTextPattern(Cp->Sx, "%SX%");
  Word_Automation.PasteTextPattern(Cp->Iy, "%IY");
  Word_Automation.PasteTextPattern(Cp->Ix, "%IX");
  Word_Automation.PasteTextPattern(Cp->tw, "%TW");
  Word_Automation.PasteTextPattern(Cp->tf, "%TF");
  Word_Automation.PasteTextPattern(Ds->gamma_c, "%GAMMA_C");
  Word_Automation.PasteTextPattern(Cp->Aw, "%AW%");
  Word_Automation.PasteTextPattern(Cp->Af, "%AF%");
  Word_Automation.PasteTextPattern((ABS(Cp->sig_xw)), "%SIGXW");
  Word_Automation.PasteTextPattern((ABS(Cp->sig_yw)), "%SIGYW");
  Word_Automation.PasteTextPattern((ABS(Cp->tau_w)), "%TAUW");
  Word_Automation.PasteTextPattern((ABS(Cp->sig_xf)), "%SIGXF");
  Word_Automation.PasteTextPattern((ABS(Cp->sig_yf)), "%SIGYF");
  Word_Automation.PasteTextPattern((ABS(Cp->tau_f)), "%TAUF");
  Word_Automation.PasteTextPattern(Cp->Rs, "%RS");
  Word_Automation.PasteTextPattern(Cp->Ry, "%RY%");
  Word_Automation.PasteTextPattern(Cp->Ryw, "%RYW");
  Word_Automation.PasteTextPattern(Cp->Mx, "%MX");
  Word_Automation.PasteTextPattern(Cp->My, "%MY");
  Word_Automation.PasteTextPattern(Round(Cp->fi_b, 2), "%FI_B");
  Word_Automation.PasteTextPattern(Cp->Wcx, "%WCX");
  Word_Automation.PasteTextPattern(Cp->Wy, "%WY");
  Word_Automation.PasteTextPattern(Round(Cp->lambda_w, 2), "%LAMBDAW");
  Word_Automation.PasteTextPattern(Round(Cp->krit_lambdaw, 2), "%KRIT_LAMBDAW");
  if (Cp->lambda_w <= Cp->krit_lambdaw ) {
	  Word_Automation.PasteTextPattern("<", "%LESS_OR_MOOR_ 9");
  }
  else
	  Word_Automation.PasteTextPattern(">", "%LESS_OR_MOOR_ 9");

  Word_Automation.PasteTextPattern(Round(Cp->sigma1w, 0), "%SIGMA1W");
  Word_Automation.PasteTextPattern(Round(Cp->lambda_f, 2), "%LAMBDAF");
  Word_Automation.PasteTextPattern(Round(Cp->lambda_uf, 2), "%LAMBDAUF");
  Word_Automation.PasteTextPattern(Round(Cp->delta_b, 1), "%DELTAB");
  Word_Automation.PasteTextPattern(Round(Cp->delta_ub, 1), "%DELTAUB");
  Word_Automation.PasteTextPattern(Round(Cp->fi_1, 2), "%FI_1");
  Word_Automation.PasteTextPattern(Round(Cp->psi, 2), "%PSI");
  Word_Automation.PasteTextPattern(Round(Cp->h_fi_b, 1), "%H%");
  Word_Automation.PasteTextPattern(Round(Cp->l_ef, 0), "%LEF");
  Word_Automation.PasteTextPattern(Round(Cp->Ey, 0), "%E%");
  if (Cp->flag_check_step) {
	  if (Cp->index_105==1) {
		 Word_Automation.PasteFilePattern("Report_Ibeam_bending%Calc_step_12_105.doc", "%CALC_STEP_12");
		 Word_Automation.PasteTextPattern(Round(Cp->lambda_b, 0), "%LAMBDA_B");
		 Word_Automation.PasteTextPattern(Round(Cp->lambda_ub, 0), "%LAMBDA_UB");
	  }
	  else {
		 Word_Automation.PasteFilePattern("Report_Ibeam_bending%Calc_step_12_106.doc", "%CALC_STEP_12");
	  }
	  Word_Automation.PasteTextPattern(Round(Cp->step_max, 0), "%STEP_EDGE");
  }
  else {
	Word_Automation.PasteTextPattern("  ", "%CALC_STEP_12");
  }
  if (Cp->N_<-10) {
	Word_Automation.PasteTextPattern("<0", "%VALUE_N");
  }
  else
	Word_Automation.PasteTextPattern("=0", "%VALUE_N");

  if (Cp->index_105==0) {
	Word_Automation.PasteTextPattern("  ", "%IND_PLAST");
  }
  else
	Word_Automation.PasteTextPattern(" ", "%IND_PLAST");
  Word_Automation.PasteTextPattern(Round(Cp->lambda_w, 2), "%LAMBDA_W");
  Word_Automation.PasteTextPattern(Round(Cp->del_lamb, 2), "%DEL_LAMB");
  if (Dt->fi_b_type_constr==0)
	 Word_Automation.PasteTextPattern("", "%SCHEMA_CONSTR");
  else
	 Word_Automation.PasteTextPattern("", "%SCHEMA_CONSTR");
	 //     0 -  , 1 -    2 -   
  switch (Dt->fi_b_num_constr) {
  case 0:
	 Word_Automation.PasteTextPattern(" ", "%SCHEMA_COUNT");
	 if (Dt->fi_b_type_load==0)
	   Word_Automation.PasteTextPattern("", "%SCHEMA_LOAD");
	 else
	   Word_Automation.PasteTextPattern(" ", "%SCHEMA_LOAD");
  break;
  case 1:
	 Word_Automation.PasteTextPattern("  ", "%SCHEMA_COUNT");
	 Word_Automation.PasteTextPattern("", "%SCHEMA_LOAD");
 break;
  case 2:
	 Word_Automation.PasteTextPattern("  ", "%SCHEMA_COUNT");
	 switch (Dt->fi_b_type_load) {
	   case 0:
		 Word_Automation.PasteTextPattern("  ", "%SCHEMA_LOAD");
	   break;
	   case 1:
		 Word_Automation.PasteTextPattern("  ", "%SCHEMA_LOAD");
	   break;
	   case 2:
		 Word_Automation.PasteTextPattern(" ", "%SCHEMA_LOAD");
	   break;
	 }
  break;
  }
  switch (Dt->fi_b_index_poyas) {
  case 0:
	 Word_Automation.PasteTextPattern("  ()  ", "%SCHEMA_UP_DOWN");
  break;
  case 1:
	 Word_Automation.PasteTextPattern("  ()  ", "%SCHEMA_UP_DOWN");
  break;
  case 2:
	 Word_Automation.PasteTextPattern("  ", "%SCHEMA_UP_DOWN");
  break;

  }

  for (i=0, k=0; i<SelectProfilSectForm->Data_select.N_check[3]; i++) {
		if (SelectProfilSectForm->Num_prov[3][i]==1) {
		  if (k<9)
			Text_coeff = "%Coeff_0"+IntToStr(k+1);
		  else
			Text_coeff = "%Coeff_"+IntToStr(k+1);
		  if (SelectProfilSectForm->Krit[3][i] >= 0) {
			Word_Automation.PasteTextPattern(FloatToStrF(SelectProfilSectForm->Krit[3][i], ffFixed, 15, 2),
			Text_coeff);
		  }
		  else {
			//Word_Automation.PasteTextPattern("-", Text_coeff);
			Word_Automation.PasteTextPattern(" -   ", Text_coeff);
		  }
		  k++;
		}
  }
}
//-------------------------------------------------------------------------------
//    -  ()
void Report_tension_bending() {

  int in, i, k;
  CHECK_ELEM_PARAM_U *Cp;
  DATA_CHECK_U *Dt;

  Dt = &(CheckExecute.Data_check_U);
  Cp = &(CheckExecute.Check_param);


  AnsiString Text_coeff;
  for (i=0, k=0; i<SelectProfilSectForm->Data_select.N_check[4]; i++) {
		if (SelectProfilSectForm->Num_prov[4][i]==1) {
		  if (k<9)
			Text_coeff = "%Coeff_0"+IntToStr(k+1);
		  else
			Text_coeff = "%Coeff_"+IntToStr(k+1);
		  if (SelectProfilSectForm->Krit[4][i] >= 0) {
			Word_Automation.PasteTextPattern(FloatToStrF(SelectProfilSectForm->Krit[4][i], ffFixed, 15, 2),
			Text_coeff);
		  }
		  else {
			Word_Automation.PasteTextPattern("-", Text_coeff);
		  }
		  k++;
		}
  }

}



