//---------------------------------------------------------------------------

#ifndef Unit2H
#define Unit2H
//---------------------------------------------------------------------------
#define vISOMETR  3
#define vDIMETR   4
#define vOBLIC    5
#define vPLANE    6

#define SHIFTY  40
#define SHIFTX  80
#define COLOR      clMedGray
#define COLOR_EDGE clScrollBar


  /*   ABS  */
#define ABS(x) (((x)<0) ? -(x):(x))
#define _ABS(x) (((x)<0) ? -(x):(x))
  /*   MIN  */
#define MIN(x,y)  (((x)<(y)) ? (x):(y))
  /*   MAX  */
#define MAX(x,y)  (((x)>(y)) ? (x):(y))

typedef struct _sect_dvutavr {
   double b;      //   
   double h;      //   
   double b1;     //    
   double h1;     //    
   double b2;     //    
   double h2;     //    
   int    n_group;   //   
   int    n_profil;  //    
   int    index_orient;   //  = 0 (  XZ)  1 (  YZ)
   int    type_prof;  //   (DVUTAVR) ,  
   float  fG;
   float  tnom;    //      
   float  b2G;     //    
   float  gG;    //
   bool flag_concl;
}  SECT_DVUTAVR;

void  Point_weld_dvutavr(int zero, int zero1, int zero2, SECT_DVUTAVR *sect, float scale, TPoint *vertices);

#endif
